using System;using LexParserTools;
namespace Absyn {
//%+Var+46
public class Var : SYMBOL{
public override string yyname { get { return "Var"; }}
public override int yynum { get { return 46; }}
public Var(Parser yyp):base(yyp){}}
//%+SimpleVar+47
public class SimpleVar : Var{
 public  Symbol . Symbol  name ;
 public  SimpleVar (Parser yyp, Symbol . Symbol  n ):base(((syntax)yyp)){ name = n ;
}

public override string yyname { get { return "SimpleVar"; }}
public override int yynum { get { return 47; }}
public SimpleVar(Parser yyp):base(yyp){}}
//%+FieldVar+48
public class FieldVar : Var{
 public  Var  var ;
 public  Symbol . Symbol  field ;
 public  FieldVar (Parser yyp, Var  v , Symbol . Symbol  f ):base(((syntax)yyp)){ var = v ;
 field = f ;
}

public override string yyname { get { return "FieldVar"; }}
public override int yynum { get { return 48; }}
public FieldVar(Parser yyp):base(yyp){}}
//%+SubscriptVar+49
public class SubscriptVar : Var{
 public  Var  var ;
 public  Exp  index ;
 public  SubscriptVar (Parser yyp, Var  v , Exp  i ):base(((syntax)yyp)){ var = v ;
 index = i ;
}

public override string yyname { get { return "SubscriptVar"; }}
public override int yynum { get { return 49; }}
public SubscriptVar(Parser yyp):base(yyp){}}
//%+Exp+50
public class Exp : SYMBOL{
public override string yyname { get { return "Exp"; }}
public override int yynum { get { return 50; }}
public Exp(Parser yyp):base(yyp){}}
//%+VarExp+51
public class VarExp : Exp{
 public  Var  var ;
 public  VarExp (Parser yyp, Var  v ):base(((syntax)yyp)){ var = v ;
}

public override string yyname { get { return "VarExp"; }}
public override int yynum { get { return 51; }}
public VarExp(Parser yyp):base(yyp){}}
//%+NilExp+52
public class NilExp : Exp{

public override string yyname { get { return "NilExp"; }}
public override int yynum { get { return 52; }}
public NilExp(Parser yyp):base(yyp){}}
//%+IntExp+53
public class IntExp : Exp{
 public  int  value ;
 public  IntExp (Parser yyp, int  i ):base(((syntax)yyp)){ value = i ;
}

public override string yyname { get { return "IntExp"; }}
public override int yynum { get { return 53; }}
public IntExp(Parser yyp):base(yyp){}}
//%+StringExp+54
public class StringExp : Exp{
 public  string  value ;
 public  StringExp (Parser yyp, string  v ):base(((syntax)yyp)){ value = v ;
}

public override string yyname { get { return "StringExp"; }}
public override int yynum { get { return 54; }}
public StringExp(Parser yyp):base(yyp){}}
//%+CallExp+55
public class CallExp : Exp{
 public  Symbol . Symbol  func ;
 public  ExpList  args ;
 public  CallExp (Parser yyp, Symbol . Symbol  f , ExpList  a ):base(((syntax)yyp)){ func = f ;
 args = a ;
}

public override string yyname { get { return "CallExp"; }}
public override int yynum { get { return 55; }}
public CallExp(Parser yyp):base(yyp){}}
//%+OpExp+56
public class OpExp : Exp{
 public  Exp  left , right ;
 public  enum  Oper { PLUS , MINUS , MUL , DIV , EQ , NE , LT , LE , GT , GE }
 public  Oper  oper ;
 public  OpExp (Parser yyp, Exp  l , Oper  o , Exp  r ):base(((syntax)yyp)){ left = l ;
 oper = o ;
 right = r ;
}

public override string yyname { get { return "OpExp"; }}
public override int yynum { get { return 56; }}
public OpExp(Parser yyp):base(yyp){}}
//%+RecordExp+57
public class RecordExp : Exp{
 public  Symbol . Symbol  typ ;
 public  FieldExpList  fields ;
 public  RecordExp (Parser yyp, Symbol . Symbol  t , FieldExpList  f ):base(((syntax)yyp)){ typ = t ;
 fields = f ;
}

public override string yyname { get { return "RecordExp"; }}
public override int yynum { get { return 57; }}
public RecordExp(Parser yyp):base(yyp){}}
//%+SeqExp+58
public class SeqExp : Exp{
 public  ExpList  list ;
 public  SeqExp (Parser yyp, ExpList  e ):base(((syntax)yyp)){ list = e ;
}

public override string yyname { get { return "SeqExp"; }}
public override int yynum { get { return 58; }}
public SeqExp(Parser yyp):base(yyp){}}
//%+AssignExp+59
public class AssignExp : Exp{
 public  Var  var ;
 public  Exp  exp ;
 public  AssignExp (Parser yyp, Var  v , Exp  e ):base(((syntax)yyp)){ var = v ;
 exp = e ;
}

public override string yyname { get { return "AssignExp"; }}
public override int yynum { get { return 59; }}
public AssignExp(Parser yyp):base(yyp){}}
//%+IfExp+60
public class IfExp : Exp{
 public  Exp  test , thenClause , elseClause ;
 public  IfExp (Parser yyp, Exp  t , Exp  tc , Exp  ec ):base(((syntax)yyp)){ test = t ;
 thenClause = tc ;
 elseClause = ec ;
}

public override string yyname { get { return "IfExp"; }}
public override int yynum { get { return 60; }}
public IfExp(Parser yyp):base(yyp){}}
//%+WhileExp+61
public class WhileExp : Exp{
 public  Exp  test , body ;
 public  WhileExp (Parser yyp, Exp  t , Exp  b ):base(((syntax)yyp)){ test = t ;
 body = b ;
}

public override string yyname { get { return "WhileExp"; }}
public override int yynum { get { return 61; }}
public WhileExp(Parser yyp):base(yyp){}}
//%+ForExp+62
public class ForExp : Exp{
 public  VarDec  var ;
 public  Exp  hi , body ;
 public  ForExp (Parser yyp, VarDec  v , Exp  h , Exp  b ):base(((syntax)yyp)){ var = v ;
 hi = h ;
 body = b ;
}

public override string yyname { get { return "ForExp"; }}
public override int yynum { get { return 62; }}
public ForExp(Parser yyp):base(yyp){}}
//%+BreakExp+63
public class BreakExp : Exp{

public override string yyname { get { return "BreakExp"; }}
public override int yynum { get { return 63; }}
public BreakExp(Parser yyp):base(yyp){}}
//%+LetExp+64
public class LetExp : Exp{
 public  DecList  decs ;
 public  Exp  body ;
 public  LetExp (Parser yyp, DecList  d , Exp  b ):base(((syntax)yyp)){ decs = d ;
 body = b ;
}

public override string yyname { get { return "LetExp"; }}
public override int yynum { get { return 64; }}
public LetExp(Parser yyp):base(yyp){}}
//%+ArrayExp+65
public class ArrayExp : Exp{
 public  Symbol . Symbol  typ ;
 public  Exp  size , init ;
 public  ArrayExp (Parser yyp, Var  v , Exp  s , Exp  i ):base(((syntax)yyp)){ Symbol . Symbol  t = null ;
 if ( v  is  SimpleVar ) t =(( SimpleVar ) v ). name ;
 else  Tiger . error ( this ,"bad array exp");
 typ = t ;
 size = s ;
 init = i ;
}

public override string yyname { get { return "ArrayExp"; }}
public override int yynum { get { return 65; }}
public ArrayExp(Parser yyp):base(yyp){}}
//%+Dec+66
public class Dec : SYMBOL{
 public  Symbol . Symbol  name ;
 public  Dec  next = null ;
 public  bool  Clash ( Dec  d ){ if ( d == null ) return  false ;
 if ( name == d . name ) return  true ;
 return  Clash ( d . next );
}

public override string yyname { get { return "Dec"; }}
public override int yynum { get { return 66; }}
public Dec(Parser yyp):base(yyp){}}
//%+FunctionDec+67
public class FunctionDec : Dec{
 public  FieldList  parms ;
 public  NameTy  result ;
 public  Exp  body ;
 public  FunctionDec (Parser yyp, Symbol . Symbol  n , FieldList  p , NameTy  r , Exp  b ):base(((syntax)yyp)){ name = n ;
 parms = p ;
 result = r ;
 body = b ;
}

public override string yyname { get { return "FunctionDec"; }}
public override int yynum { get { return 67; }}
public FunctionDec(Parser yyp):base(yyp){}}
//%+VarDec+68
public class VarDec : Dec{
 public  NameTy  typ ;
 public  Exp  init ;
 public  bool  escape ;
 public  VarDec (Parser yyp, Symbol . Symbol  n , NameTy  t , Exp  i ):base(((syntax)yyp)){ name = n ;
 typ = t ;
 init = i ;
}

public override string yyname { get { return "VarDec"; }}
public override int yynum { get { return 68; }}
public VarDec(Parser yyp):base(yyp){}}
//%+TypeDec+69
public class TypeDec : Dec{
 public  Ty  ty ;
 public  TypeDec (Parser yyp, Symbol . Symbol  n , Ty  t ):base(((syntax)yyp)){ name = n ;
 ty = t ;
}

public override string yyname { get { return "TypeDec"; }}
public override int yynum { get { return 69; }}
public TypeDec(Parser yyp):base(yyp){}}
//%+DecVar+70
public class DecVar : SYMBOL{
 public  Symbol . Symbol  name ;
 public  NameTy  typ ;
 public  Exp  init ;
 public  DecVar (Parser yyp, Symbol . Symbol  n , NameTy  t , Exp  i ):base(((syntax)yyp)){ name = n ;
 typ = t ;
 init = i ;
}

public override string yyname { get { return "DecVar"; }}
public override int yynum { get { return 70; }}
public DecVar(Parser yyp):base(yyp){}}
//%+Ty+71
public class Ty : SYMBOL{
public override string yyname { get { return "Ty"; }}
public override int yynum { get { return 71; }}
public Ty(Parser yyp):base(yyp){}}
//%+NameTy+72
public class NameTy : Ty{
 public  Symbol . Symbol  name ;
 public  NameTy (Parser yyp, Symbol . Symbol  n ):base(((syntax)yyp)){ name = n ;
}

public override string yyname { get { return "NameTy"; }}
public override int yynum { get { return 72; }}
public NameTy(Parser yyp):base(yyp){}}
//%+RecordTy+73
public class RecordTy : Ty{
 public  FieldList  fields ;
 public  RecordTy (Parser yyp, FieldList  f ):base(((syntax)yyp)){ fields = f ;
}

public override string yyname { get { return "RecordTy"; }}
public override int yynum { get { return 73; }}
public RecordTy(Parser yyp):base(yyp){}}
//%+ArrayTy+74
public class ArrayTy : Ty{
 public  Symbol . Symbol  typ ;
 public  ArrayTy (Parser yyp, Symbol . Symbol  t ):base(((syntax)yyp)){ typ = t ;
}

public override string yyname { get { return "ArrayTy"; }}
public override int yynum { get { return 74; }}
public ArrayTy(Parser yyp):base(yyp){}}
//%+DecList+75
public class DecList : SYMBOL{
 public  Dec  head ;
 public  DecList  tail ;
 public  DecList (Parser yyp, Dec  d , DecList  t ):base(((syntax)yyp)){ head = d ;
 tail = t ;
}
 public  virtual  bool  IsEmpty (){ return  false ;
}

public override string yyname { get { return "DecList"; }}
public override int yynum { get { return 75; }}
public DecList(Parser yyp):base(yyp){}}
//%+ExpList+76
public class ExpList : SYMBOL{
 public  Exp  head ;
 public  ExpList  tail ;
 public  ExpList (Parser yyp, Exp  h , ExpList  t ):base(((syntax)yyp)){ head = h ;
 tail = t ;
}

public override string yyname { get { return "ExpList"; }}
public override int yynum { get { return 76; }}
public ExpList(Parser yyp):base(yyp){}}
//%+FieldList+77
public class FieldList : SYMBOL{
 public  Symbol . Symbol  name , typ ;
 public  FieldList  tail ;
 public  bool  escape ;
 public  FieldList (Parser yyp, Symbol . Symbol  n , Symbol . Symbol  t , FieldList  f ):base(((syntax)yyp)){ name = n ;
 typ = t ;
 tail = f ;
}
 public  Util . BoolList  escList { get { Util . BoolList  t = null ;
 if ( tail != null ) t = tail . escList ;
 return  new  Util . BoolList ( escape , t );
}
}

public override string yyname { get { return "FieldList"; }}
public override int yynum { get { return 77; }}
public FieldList(Parser yyp):base(yyp){}}
//%+FieldExpList+78
public class FieldExpList : SYMBOL{
 public  Symbol . Symbol  name ;
 public  Exp  init ;
 public  FieldExpList  tail ;
 public  FieldExpList (Parser yyp, Symbol . Symbol  n , Exp  i , FieldExpList  t ):base(((syntax)yyp)){ name = n ;
 init = i ;
 tail = t ;
}

public override string yyname { get { return "FieldExpList"; }}
public override int yynum { get { return 78; }}
public FieldExpList(Parser yyp):base(yyp){}}
//%+ParamList+79
public class ParamList : ExpList{
 public  ParamList (Parser yyp, Exp  h , ParamList  t ):base(((syntax)yyp), h , t ){}

public override string yyname { get { return "ParamList"; }}
public override int yynum { get { return 79; }}
public ParamList(Parser yyp):base(yyp){}}

public class Null_1 : Null {
  public Null_1(Parser yyq):base(yyq,"DecList"){}}

public class DecList_1 : DecList {
  public DecList_1(Parser yyq):base(yyq,
	((Dec)(yyq.StackAt(1).m_value))
	,
	((DecList)(yyq.StackAt(0).m_value))
	){}}

public class NameTy_1 : NameTy {
  public NameTy_1(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(0).m_value))
	.id){}}

public class RecordTy_1 : RecordTy {
  public RecordTy_1(Parser yyq):base(yyq,null){}}

public class RecordTy_2 : RecordTy {
  public RecordTy_2(Parser yyq):base(yyq,
	((FieldList)(yyq.StackAt(1).m_value))
	){}}

public class ArrayTy_1 : ArrayTy {
  public ArrayTy_1(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(0).m_value))
	.id){}}

public class FieldList_1 : FieldList {
  public FieldList_1(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(2).m_value))
	.id,
	((ID)(yyq.StackAt(0).m_value))
	.id,null){}}

public class FieldList_2 : FieldList {
  public FieldList_2(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(4).m_value))
	.id,
	((ID)(yyq.StackAt(2).m_value))
	.id,
	((FieldList)(yyq.StackAt(0).m_value))
	){}}

public class DecVar_1 : DecVar {
  public DecVar_1(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(2).m_value))
	.id,null,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class DecVar_2 : DecVar {
  public DecVar_2(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(4).m_value))
	.id,new NameTy(((syntax)yyq),
	((ID)(yyq.StackAt(2).m_value))
	.id),
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class VarDec_1 : VarDec {
  public VarDec_1(Parser yyq):base(yyq,
	((DecVar)(yyq.StackAt(0).m_value))
	.name,
	((DecVar)(yyq.StackAt(0).m_value))
	.typ,
	((DecVar)(yyq.StackAt(0).m_value))
	.init){}}

public class TypeDec_1 : TypeDec {
  public TypeDec_1(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(2).m_value))
	.id,
	((Ty)(yyq.StackAt(0).m_value))
	){}}

public class FunctionDec_1 : FunctionDec {
  public FunctionDec_1(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(5).m_value))
	.id,
	((FieldList)(yyq.StackAt(3).m_value))
	,null,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class FunctionDec_2 : FunctionDec {
  public FunctionDec_2(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(7).m_value))
	.id,
	((FieldList)(yyq.StackAt(5).m_value))
	,new NameTy(((syntax)yyq),
	((ID)(yyq.StackAt(2).m_value))
	.id),
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class FunctionDec_3 : FunctionDec {
  public FunctionDec_3(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(4).m_value))
	.id,null,null,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class FunctionDec_4 : FunctionDec {
  public FunctionDec_4(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(6).m_value))
	.id,null,new NameTy(((syntax)yyq),
	((ID)(yyq.StackAt(2).m_value))
	.id),
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class SimpleVar_1 : SimpleVar {
  public SimpleVar_1(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(0).m_value))
	.id){}}

public class FieldVar_1 : FieldVar {
  public FieldVar_1(Parser yyq):base(yyq,
	((Var)(yyq.StackAt(2).m_value))
	,
	((ID)(yyq.StackAt(0).m_value))
	.id){}}

public class SubscriptVar_1 : SubscriptVar {
  public SubscriptVar_1(Parser yyq):base(yyq,
	((Var)(yyq.StackAt(3).m_value))
	,
	((Exp)(yyq.StackAt(1).m_value))
	){}}

public class ExpList_1 : ExpList {
  public ExpList_1(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(0).m_value))
	,null){}}

public class ExpList_2 : ExpList {
  public ExpList_2(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,
	((ExpList)(yyq.StackAt(0).m_value))
	){}}

public class ParamList_1 : ParamList {
  public ParamList_1(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(0).m_value))
	,null){}}

public class ParamList_2 : ParamList {
  public ParamList_2(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,
	((ParamList)(yyq.StackAt(0).m_value))
	){}}

public class FieldExpList_1 : FieldExpList {
  public FieldExpList_1(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(2).m_value))
	.id,
	((Exp)(yyq.StackAt(0).m_value))
	,null){}}

public class FieldExpList_2 : FieldExpList {
  public FieldExpList_2(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(4).m_value))
	.id,
	((Exp)(yyq.StackAt(2).m_value))
	,
	((FieldExpList)(yyq.StackAt(0).m_value))
	){}}

public class VarExp_1 : VarExp {
  public VarExp_1(Parser yyq):base(yyq,
	((Var)(yyq.StackAt(0).m_value))
	){}}

public class NilExp_1 : NilExp {
  public NilExp_1(Parser yyq):base(yyq){}}

public class SeqExp_1 : SeqExp {
  public SeqExp_1(Parser yyq):base(yyq,null){}}

public class SeqExp_2 : SeqExp {
  public SeqExp_2(Parser yyq):base(yyq,
	((ExpList)(yyq.StackAt(1).m_value))
	){}}

public class IntExp_1 : IntExp {
  public IntExp_1(Parser yyq):base(yyq,
	((INT)(yyq.StackAt(0).m_value))
	.val){}}

public class StringExp_1 : StringExp {
  public StringExp_1(Parser yyq):base(yyq,
	((STRING)(yyq.StackAt(0).m_value))
	.yytext){}}

public class OpExp_1 : OpExp {
  public OpExp_1(Parser yyq):base(yyq,new IntExp(((syntax)yyq),0),OpExp.Oper.MINUS,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class CallExp_1 : CallExp {
  public CallExp_1(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(2).m_value))
	.id,null){}}

public class CallExp_2 : CallExp {
  public CallExp_2(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(3).m_value))
	.id,
	((ParamList)(yyq.StackAt(1).m_value))
	){}}

public class OpExp_2 : OpExp {
  public OpExp_2(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,OpExp.Oper.PLUS,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class OpExp_3 : OpExp {
  public OpExp_3(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,OpExp.Oper.MINUS,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class OpExp_4 : OpExp {
  public OpExp_4(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,OpExp.Oper.MUL,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class OpExp_5 : OpExp {
  public OpExp_5(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,OpExp.Oper.DIV,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class OpExp_6 : OpExp {
  public OpExp_6(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,OpExp.Oper.EQ,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class OpExp_7 : OpExp {
  public OpExp_7(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,OpExp.Oper.NE,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class OpExp_8 : OpExp {
  public OpExp_8(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,OpExp.Oper.LT,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class OpExp_9 : OpExp {
  public OpExp_9(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,OpExp.Oper.LE,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class OpExp_10 : OpExp {
  public OpExp_10(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,OpExp.Oper.GT,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class OpExp_11 : OpExp {
  public OpExp_11(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,OpExp.Oper.GE,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class IfExp_1 : IfExp {
  public IfExp_1(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,
	((Exp)(yyq.StackAt(0).m_value))
	,new IntExp(((syntax)yyq),0)){}}

public class IfExp_2 : IfExp {
  public IfExp_2(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,new IntExp(((syntax)yyq),1),
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class RecordExp_1 : RecordExp {
  public RecordExp_1(Parser yyq):base(yyq,
	((ID)(yyq.StackAt(3).m_value))
	.id,
	((FieldExpList)(yyq.StackAt(1).m_value))
	){}}

public class ArrayExp_1 : ArrayExp {
  public ArrayExp_1(Parser yyq):base(yyq,
	((Var)(yyq.StackAt(5).m_value))
	,
	((Exp)(yyq.StackAt(3).m_value))
	,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class AssignExp_1 : AssignExp {
  public AssignExp_1(Parser yyq):base(yyq,
	((Var)(yyq.StackAt(2).m_value))
	,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class IfExp_3 : IfExp {
  public IfExp_3(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(4).m_value))
	,
	((Exp)(yyq.StackAt(2).m_value))
	,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class IfExp_4 : IfExp {
  public IfExp_4(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,
	((Exp)(yyq.StackAt(0).m_value))
	,null){}}

public class WhileExp_1 : WhileExp {
  public WhileExp_1(Parser yyq):base(yyq,
	((Exp)(yyq.StackAt(2).m_value))
	,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class ForExp_1 : ForExp {
  public ForExp_1(Parser yyq):base(yyq,new VarDec(((syntax)yyq),
	((DecVar)(yyq.StackAt(4).m_value))
	.name,
	((DecVar)(yyq.StackAt(4).m_value))
	.typ,
	((DecVar)(yyq.StackAt(4).m_value))
	.init),
	((Exp)(yyq.StackAt(2).m_value))
	,
	((Exp)(yyq.StackAt(0).m_value))
	){}}

public class BreakExp_1 : BreakExp {
  public BreakExp_1(Parser yyq):base(yyq){}}

public class LetExp_1 : LetExp {
  public LetExp_1(Parser yyq):base(yyq,
	((DecList)(yyq.StackAt(2).m_value))
	,null){}}

public class LetExp_2 : LetExp {
  public LetExp_2(Parser yyq):base(yyq,
	((DecList)(yyq.StackAt(3).m_value))
	,new SeqExp(((syntax)yyq),
	((ExpList)(yyq.StackAt(1).m_value))
	)){}}
public class yysyntax: YyParser {
  public override object Action(Parser yyq,SYMBOL yysym, int yyact) {
    switch(yyact) {
	 case -1: break; //// keep compiler happy
}  return null; }
public yysyntax():base() { arr = new int[] { 
101,4,6,52,0,
46,0,53,0,102,
20,103,4,6,69,
0,120,0,112,0,
1,50,1,2,104,
18,1,930,102,2,
0,105,5,134,1,
472,106,18,1,472,
107,20,108,4,4,
79,0,70,0,1,
40,1,1,2,0,
1,471,109,18,1,
471,110,20,111,4,
12,82,0,66,0,
82,0,65,0,67,
0,75,0,1,12,
1,1,2,0,1,
470,112,18,1,470,
102,2,0,1,229,
113,18,1,229,102,
2,0,1,943,114,
18,1,943,115,23,
116,4,6,69,0,
79,0,70,0,1,
2,1,6,2,0,
1,463,117,18,1,
463,118,20,119,4,
12,76,0,66,0,
82,0,65,0,67,
0,75,0,1,11,
1,1,2,0,1,
221,120,18,1,221,
121,20,122,4,8,
80,0,76,0,85,
0,83,0,1,16,
1,1,2,0,1,
907,123,18,1,907,
107,2,0,1,878,
124,18,1,878,102,
2,0,1,902,125,
18,1,902,126,20,
127,4,8,84,0,
89,0,80,0,69,
0,1,45,1,1,
2,0,1,900,128,
18,1,900,129,20,
130,4,18,70,0,
105,0,101,0,108,
0,100,0,76,0,
105,0,115,0,116,
0,1,77,1,2,
2,0,1,899,131,
18,1,899,132,20,
133,4,10,67,0,
79,0,77,0,77,
0,65,0,1,6,
1,1,2,0,1,
897,134,18,1,897,
135,20,136,4,10,
67,0,79,0,76,
0,79,0,78,0,
1,7,1,1,2,
0,1,209,137,18,
1,209,102,2,0,
1,922,138,18,1,
922,139,20,140,4,
14,68,0,101,0,
99,0,76,0,105,
0,115,0,116,0,
1,75,1,2,2,
0,1,201,141,18,
1,201,142,20,143,
4,10,77,0,73,
0,78,0,85,0,
83,0,1,17,1,
1,2,0,1,916,
144,18,1,916,145,
20,146,4,12,68,
0,101,0,99,0,
86,0,97,0,114,
0,1,70,1,2,
2,0,1,915,147,
18,1,915,148,20,
149,4,6,86,0,
65,0,82,0,1,
44,1,1,2,0,
1,914,150,18,1,
914,151,20,152,4,
4,73,0,68,0,
1,4,1,1,2,
0,1,913,153,18,
1,913,154,20,155,
4,12,82,0,66,
0,82,0,65,0,
67,0,69,0,1,
14,1,1,2,0,
1,912,156,18,1,
912,154,2,0,1,
911,157,18,1,911,
129,2,0,1,909,
158,18,1,909,159,
20,160,4,12,76,
0,66,0,82,0,
65,0,67,0,69,
0,1,13,1,1,
2,0,1,430,161,
18,1,430,102,2,
0,1,190,162,18,
1,190,102,2,0,
1,182,163,18,1,
182,164,20,165,4,
10,84,0,73,0,
77,0,69,0,83,
0,1,18,1,1,
2,0,1,905,166,
18,1,905,167,20,
168,4,4,84,0,
121,0,1,71,1,
2,2,0,1,904,
169,18,1,904,170,
20,171,4,4,69,
0,81,0,1,20,
1,1,2,0,1,
903,172,18,1,903,
151,2,0,1,424,
173,18,1,424,174,
20,175,4,12,82,
0,80,0,65,0,
82,0,69,0,78,
0,1,10,1,1,
2,0,1,423,176,
18,1,423,174,2,
0,1,422,177,18,
1,422,178,20,179,
4,18,80,0,97,
0,114,0,97,0,
109,0,76,0,105,
0,115,0,116,0,
1,79,1,2,2,
0,1,421,180,18,
1,421,178,2,0,
1,898,181,18,1,
898,151,2,0,1,
841,182,18,1,841,
174,2,0,1,840,
183,18,1,840,129,
2,0,1,656,184,
18,1,656,102,2,
0,1,172,185,18,
1,172,102,2,0,
1,394,186,18,1,
394,102,2,0,1,
407,187,18,1,407,
132,2,0,1,164,
188,18,1,164,189,
20,190,4,12,68,
0,73,0,86,0,
73,0,68,0,69,
0,1,19,1,1,
2,0,1,386,191,
18,1,386,192,20,
193,4,12,76,0,
80,0,65,0,82,
0,69,0,78,0,
1,9,1,1,2,
0,1,155,194,18,
1,155,102,2,0,
1,870,195,18,1,
870,170,2,0,1,
378,196,18,1,378,
132,2,0,1,814,
197,18,1,814,170,
2,0,1,147,198,
18,1,147,170,2,
0,1,379,199,18,
1,379,200,20,201,
4,24,70,0,105,
0,101,0,108,0,
100,0,69,0,120,
0,112,0,76,0,
105,0,115,0,116,
0,1,78,1,2,
2,0,1,139,202,
18,1,139,102,2,
0,1,852,203,18,
1,852,102,2,0,
1,131,204,18,1,
131,205,20,206,4,
6,78,0,69,0,
81,0,1,21,1,
1,2,0,1,844,
207,18,1,844,170,
2,0,1,843,208,
18,1,843,151,2,
0,1,842,209,18,
1,842,135,2,0,
1,124,210,18,1,
124,102,2,0,1,
720,211,18,1,720,
212,20,213,4,12,
65,0,83,0,83,
0,73,0,71,0,
78,0,1,28,1,
1,2,0,1,595,
214,18,1,595,102,
2,0,1,116,215,
18,1,116,216,20,
217,4,4,76,0,
84,0,1,22,1,
1,2,0,1,754,
218,18,1,754,102,
2,0,1,110,219,
18,1,110,102,2,
0,1,822,220,18,
1,822,102,2,0,
1,102,221,18,1,
102,222,20,223,4,
4,76,0,69,0,
1,23,1,1,2,
0,1,305,224,18,
1,305,225,20,226,
4,14,69,0,120,
0,112,0,76,0,
105,0,115,0,116,
0,1,76,1,2,
2,0,1,97,227,
18,1,97,102,2,
0,1,786,228,18,
1,786,135,2,0,
1,784,229,18,1,
784,192,2,0,1,
783,230,18,1,783,
151,2,0,1,89,
231,18,1,89,170,
2,0,1,88,232,
18,1,88,151,2,
0,1,87,233,18,
1,87,154,2,0,
1,86,234,18,1,
86,200,2,0,1,
85,235,18,1,85,
159,2,0,1,84,
236,18,1,84,151,
2,0,1,796,237,
18,1,796,102,2,
0,1,306,238,18,
1,306,174,2,0,
1,77,239,18,1,
77,240,20,241,4,
4,71,0,84,0,
1,24,1,1,2,
0,1,517,242,18,
1,517,151,2,0,
1,719,243,18,1,
719,151,2,0,1,
73,244,18,1,73,
102,2,0,1,788,
245,18,1,788,170,
2,0,1,787,246,
18,1,787,151,2,
0,1,308,247,18,
1,308,174,2,0,
1,785,248,18,1,
785,174,2,0,1,
67,249,18,1,67,
212,2,0,1,66,
250,18,1,66,251,
20,252,4,6,86,
0,97,0,114,0,
1,46,1,2,2,
0,1,782,253,18,
1,782,254,20,255,
4,16,70,0,85,
0,78,0,67,0,
84,0,73,0,79,
0,78,0,1,43,
1,1,2,0,1,
301,256,18,1,301,
225,2,0,1,300,
257,18,1,300,258,
20,259,4,6,78,
0,73,0,76,0,
1,42,1,1,2,
0,1,60,260,18,
1,60,261,20,262,
4,4,71,0,69,
0,1,25,1,1,
2,0,1,728,263,
18,1,728,102,2,
0,1,57,264,18,
1,57,102,2,0,
1,51,265,18,1,
51,266,20,267,4,
8,69,0,76,0,
83,0,69,0,1,
32,1,1,2,0,
1,50,268,18,1,
50,102,2,0,1,
718,269,18,1,718,
135,2,0,1,287,
270,18,1,287,271,
20,272,4,18,83,
0,69,0,77,0,
73,0,67,0,79,
0,76,0,79,0,
78,0,1,8,1,
1,2,0,1,45,
273,18,1,45,274,
20,275,4,8,84,
0,72,0,69,0,
78,0,1,31,1,
1,2,0,1,44,
276,18,1,44,102,
2,0,1,908,277,
18,1,908,151,2,
0,1,519,278,18,
1,519,102,2,0,
1,906,279,18,1,
906,280,20,281,4,
10,65,0,82,0,
82,0,65,0,89,
0,1,29,1,1,
2,0,1,39,282,
18,1,39,283,20,
284,4,4,73,0,
70,0,1,30,1,
1,2,0,1,516,
285,18,1,516,286,
20,287,4,6,68,
0,79,0,84,0,
1,15,1,1,2,
0,1,266,288,18,
1,266,192,2,0,
1,930,104,1,274,
289,18,1,274,102,
2,0,1,34,290,
18,1,34,291,20,
292,4,6,65,0,
78,0,68,0,1,
26,1,1,2,0,
1,32,293,18,1,
32,102,2,0,1,
896,294,18,1,896,
151,2,0,1,746,
295,18,1,746,212,
2,0,1,28,296,
18,1,28,297,20,
298,4,4,68,0,
79,0,1,36,1,
1,2,0,1,27,
299,18,1,27,102,
2,0,1,265,300,
18,1,265,301,20,
302,4,6,73,0,
78,0,84,0,1,
5,1,1,2,0,
1,264,303,18,1,
264,304,20,305,4,
12,83,0,84,0,
82,0,73,0,78,
0,71,0,1,3,
1,1,2,0,1,
717,306,18,1,717,
151,2,0,1,23,
307,18,1,23,308,
20,309,4,10,87,
0,72,0,73,0,
76,0,69,0,1,
33,1,1,2,0,
1,918,310,18,1,
918,311,20,312,4,
6,68,0,101,0,
99,0,1,66,1,
2,2,0,1,250,
313,18,1,250,102,
2,0,1,19,314,
18,1,19,315,20,
316,4,4,79,0,
82,0,1,27,1,
1,2,0,1,18,
317,18,1,18,102,
2,0,1,479,318,
18,1,479,102,2,
0,1,15,319,18,
1,15,297,2,0,
1,14,320,18,1,
14,102,2,0,1,
242,321,18,1,242,
142,2,0,1,11,
322,18,1,11,323,
20,324,4,4,84,
0,79,0,1,35,
1,1,2,0,1,
10,325,18,1,10,
145,2,0,1,9,
326,18,1,9,327,
20,328,4,6,70,
0,79,0,82,0,
1,34,1,1,2,
0,1,8,329,18,
1,8,330,20,331,
4,10,66,0,82,
0,69,0,65,0,
75,0,1,41,1,
1,2,0,1,7,
332,18,1,7,333,
20,334,4,6,69,
0,78,0,68,0,
1,39,1,1,2,
0,1,5,335,18,
1,5,333,2,0,
1,4,336,18,1,
4,225,2,0,1,
3,337,18,1,3,
338,20,339,4,4,
73,0,78,0,1,
38,1,1,2,0,
1,2,340,18,1,
2,139,2,0,1,
1,341,18,1,1,
342,20,343,4,6,
76,0,69,0,84,
0,1,37,1,1,
2,0,1,0,344,
18,1,0,0,2,
0,345,5,0,346,
5,135,1,136,347,
19,348,4,16,76,
0,101,0,116,0,
69,0,120,0,112,
0,95,0,50,0,
1,136,349,5,36,
1,746,350,16,0,
218,1,102,351,16,
0,219,1,844,352,
16,0,203,1,201,
353,16,0,137,1,
814,354,16,0,220,
1,89,355,16,0,
227,1,407,356,16,
0,186,1,720,357,
16,0,263,1,77,
358,16,0,161,1,
182,359,16,0,162,
1,287,360,16,0,
289,1,67,361,16,
0,244,1,386,362,
16,0,186,1,60,
363,16,0,278,1,
164,364,16,0,185,
1,266,365,16,0,
289,1,51,366,16,
0,264,1,45,367,
16,0,268,1,472,
368,16,0,318,1,
39,369,16,0,276,
1,147,370,16,0,
194,1,788,371,16,
0,237,1,463,372,
16,0,112,1,34,
373,16,0,214,1,
28,374,16,0,293,
1,242,375,16,0,
313,1,131,376,16,
0,202,1,23,377,
16,0,299,1,19,
378,16,0,184,1,
15,379,16,0,317,
1,870,380,16,0,
124,1,11,381,16,
0,320,1,116,382,
16,0,210,1,221,
383,16,0,113,1,
3,384,16,0,289,
1,0,385,16,0,
104,1,135,386,19,
387,4,16,76,0,
101,0,116,0,69,
0,120,0,112,0,
95,0,49,0,1,
135,349,1,134,388,
19,389,4,20,66,
0,114,0,101,0,
97,0,107,0,69,
0,120,0,112,0,
95,0,49,0,1,
134,349,1,133,390,
19,391,4,16,70,
0,111,0,114,0,
69,0,120,0,112,
0,95,0,49,0,
1,133,349,1,132,
392,19,393,4,20,
87,0,104,0,105,
0,108,0,101,0,
69,0,120,0,112,
0,95,0,49,0,
1,132,349,1,131,
394,19,395,4,14,
73,0,102,0,69,
0,120,0,112,0,
95,0,52,0,1,
131,349,1,130,396,
19,397,4,14,73,
0,102,0,69,0,
120,0,112,0,95,
0,51,0,1,130,
349,1,129,398,19,
399,4,22,65,0,
115,0,115,0,105,
0,103,0,110,0,
69,0,120,0,112,
0,95,0,49,0,
1,129,349,1,128,
400,19,401,4,20,
65,0,114,0,114,
0,97,0,121,0,
69,0,120,0,112,
0,95,0,49,0,
1,128,349,1,127,
402,19,403,4,22,
82,0,101,0,99,
0,111,0,114,0,
100,0,69,0,120,
0,112,0,95,0,
49,0,1,127,349,
1,126,404,19,405,
4,14,73,0,102,
0,69,0,120,0,
112,0,95,0,50,
0,1,126,349,1,
125,406,19,407,4,
14,73,0,102,0,
69,0,120,0,112,
0,95,0,49,0,
1,125,349,1,124,
408,19,409,4,16,
79,0,112,0,69,
0,120,0,112,0,
95,0,49,0,49,
0,1,124,349,1,
123,410,19,411,4,
16,79,0,112,0,
69,0,120,0,112,
0,95,0,49,0,
48,0,1,123,349,
1,122,412,19,413,
4,14,79,0,112,
0,69,0,120,0,
112,0,95,0,57,
0,1,122,349,1,
121,414,19,415,4,
14,79,0,112,0,
69,0,120,0,112,
0,95,0,56,0,
1,121,349,1,120,
416,19,417,4,14,
79,0,112,0,69,
0,120,0,112,0,
95,0,55,0,1,
120,349,1,119,418,
19,419,4,14,79,
0,112,0,69,0,
120,0,112,0,95,
0,54,0,1,119,
349,1,118,420,19,
421,4,14,79,0,
112,0,69,0,120,
0,112,0,95,0,
53,0,1,118,349,
1,117,422,19,423,
4,14,79,0,112,
0,69,0,120,0,
112,0,95,0,52,
0,1,117,349,1,
116,424,19,425,4,
14,79,0,112,0,
69,0,120,0,112,
0,95,0,51,0,
1,116,349,1,115,
426,19,427,4,14,
79,0,112,0,69,
0,120,0,112,0,
95,0,50,0,1,
115,349,1,114,428,
19,429,4,18,67,
0,97,0,108,0,
108,0,69,0,120,
0,112,0,95,0,
50,0,1,114,349,
1,113,430,19,431,
4,18,67,0,97,
0,108,0,108,0,
69,0,120,0,112,
0,95,0,49,0,
1,113,349,1,112,
432,19,433,4,14,
79,0,112,0,69,
0,120,0,112,0,
95,0,49,0,1,
112,349,1,111,434,
19,435,4,22,83,
0,116,0,114,0,
105,0,110,0,103,
0,69,0,120,0,
112,0,95,0,49,
0,1,111,349,1,
110,436,19,437,4,
16,73,0,110,0,
116,0,69,0,120,
0,112,0,95,0,
49,0,1,110,349,
1,109,438,19,439,
4,16,83,0,101,
0,113,0,69,0,
120,0,112,0,95,
0,50,0,1,109,
349,1,108,440,19,
441,4,16,83,0,
101,0,113,0,69,
0,120,0,112,0,
95,0,49,0,1,
108,349,1,107,442,
19,443,4,16,78,
0,105,0,108,0,
69,0,120,0,112,
0,95,0,49,0,
1,107,349,1,106,
444,19,445,4,16,
86,0,97,0,114,
0,69,0,120,0,
112,0,95,0,49,
0,1,106,349,1,
105,446,19,447,4,
28,70,0,105,0,
101,0,108,0,100,
0,69,0,120,0,
112,0,76,0,105,
0,115,0,116,0,
95,0,50,0,1,
105,448,5,2,1,
85,449,16,0,234,
1,378,450,16,0,
199,1,104,451,19,
452,4,28,70,0,
105,0,101,0,108,
0,100,0,69,0,
120,0,112,0,76,
0,105,0,115,0,
116,0,95,0,49,
0,1,104,448,1,
103,453,19,454,4,
22,80,0,97,0,
114,0,97,0,109,
0,76,0,105,0,
115,0,116,0,95,
0,50,0,1,103,
455,5,2,1,386,
456,16,0,177,1,
407,457,16,0,180,
1,102,458,19,459,
4,22,80,0,97,
0,114,0,97,0,
109,0,76,0,105,
0,115,0,116,0,
95,0,49,0,1,
102,455,1,101,460,
19,461,4,18,69,
0,120,0,112,0,
76,0,105,0,115,
0,116,0,95,0,
50,0,1,101,462,
5,3,1,3,463,
16,0,336,1,266,
464,16,0,224,1,
287,465,16,0,256,
1,100,466,19,467,
4,18,69,0,120,
0,112,0,76,0,
105,0,115,0,116,
0,95,0,49,0,
1,100,462,1,99,
468,19,469,4,28,
83,0,117,0,98,
0,115,0,99,0,
114,0,105,0,112,
0,116,0,86,0,
97,0,114,0,95,
0,49,0,1,99,
470,5,36,1,746,
471,16,0,250,1,
102,472,16,0,250,
1,844,473,16,0,
250,1,201,474,16,
0,250,1,814,475,
16,0,250,1,89,
476,16,0,250,1,
407,477,16,0,250,
1,720,478,16,0,
250,1,77,479,16,
0,250,1,182,480,
16,0,250,1,287,
481,16,0,250,1,
67,482,16,0,250,
1,386,483,16,0,
250,1,60,484,16,
0,250,1,164,485,
16,0,250,1,266,
486,16,0,250,1,
51,487,16,0,250,
1,45,488,16,0,
250,1,472,489,16,
0,250,1,39,490,
16,0,250,1,147,
491,16,0,250,1,
788,492,16,0,250,
1,463,493,16,0,
250,1,34,494,16,
0,250,1,28,495,
16,0,250,1,242,
496,16,0,250,1,
131,497,16,0,250,
1,23,498,16,0,
250,1,19,499,16,
0,250,1,15,500,
16,0,250,1,870,
501,16,0,250,1,
11,502,16,0,250,
1,116,503,16,0,
250,1,221,504,16,
0,250,1,3,505,
16,0,250,1,0,
506,16,0,250,1,
98,507,19,508,4,
20,70,0,105,0,
101,0,108,0,100,
0,86,0,97,0,
114,0,95,0,49,
0,1,98,470,1,
97,509,19,510,4,
22,83,0,105,0,
109,0,112,0,108,
0,101,0,86,0,
97,0,114,0,95,
0,49,0,1,97,
470,1,96,511,19,
512,4,26,70,0,
117,0,110,0,99,
0,116,0,105,0,
111,0,110,0,68,
0,101,0,99,0,
95,0,52,0,1,
96,513,5,2,1,
918,514,16,0,310,
1,1,515,16,0,
310,1,95,516,19,
517,4,26,70,0,
117,0,110,0,99,
0,116,0,105,0,
111,0,110,0,68,
0,101,0,99,0,
95,0,51,0,1,
95,513,1,94,518,
19,519,4,26,70,
0,117,0,110,0,
99,0,116,0,105,
0,111,0,110,0,
68,0,101,0,99,
0,95,0,50,0,
1,94,513,1,93,
520,19,521,4,26,
70,0,117,0,110,
0,99,0,116,0,
105,0,111,0,110,
0,68,0,101,0,
99,0,95,0,49,
0,1,93,513,1,
92,522,19,523,4,
18,84,0,121,0,
112,0,101,0,68,
0,101,0,99,0,
95,0,49,0,1,
92,513,1,91,524,
19,525,4,16,86,
0,97,0,114,0,
68,0,101,0,99,
0,95,0,49,0,
1,91,513,1,90,
526,19,527,4,16,
68,0,101,0,99,
0,86,0,97,0,
114,0,95,0,50,
0,1,90,528,5,
2,1,9,529,16,
0,325,1,915,530,
16,0,144,1,89,
531,19,532,4,16,
68,0,101,0,99,
0,86,0,97,0,
114,0,95,0,49,
0,1,89,528,1,
88,533,19,534,4,
22,70,0,105,0,
101,0,108,0,100,
0,76,0,105,0,
115,0,116,0,95,
0,50,0,1,88,
535,5,3,1,899,
536,16,0,128,1,
909,537,16,0,157,
1,784,538,16,0,
183,1,87,539,19,
540,4,22,70,0,
105,0,101,0,108,
0,100,0,76,0,
105,0,115,0,116,
0,95,0,49,0,
1,87,535,1,86,
541,19,542,4,18,
65,0,114,0,114,
0,97,0,121,0,
84,0,121,0,95,
0,49,0,1,86,
543,5,1,1,904,
544,16,0,166,1,
85,545,19,546,4,
20,82,0,101,0,
99,0,111,0,114,
0,100,0,84,0,
121,0,95,0,50,
0,1,85,543,1,
84,547,19,548,4,
20,82,0,101,0,
99,0,111,0,114,
0,100,0,84,0,
121,0,95,0,49,
0,1,84,543,1,
83,549,19,550,4,
16,78,0,97,0,
109,0,101,0,84,
0,121,0,95,0,
49,0,1,83,543,
1,82,551,19,552,
4,18,68,0,101,
0,99,0,76,0,
105,0,115,0,116,
0,95,0,49,0,
1,82,553,5,2,
1,918,554,16,0,
138,1,1,555,16,
0,340,1,81,556,
19,557,4,12,78,
0,117,0,108,0,
108,0,95,0,49,
0,1,81,558,5,
0,1,80,559,19,
560,4,8,78,0,
117,0,108,0,108,
0,1,80,558,1,
79,561,19,179,1,
79,455,1,78,562,
19,201,1,78,448,
1,77,563,19,130,
1,77,535,1,76,
564,19,226,1,76,
462,1,75,565,19,
140,1,75,553,1,
74,566,19,567,4,
14,65,0,114,0,
114,0,97,0,121,
0,84,0,121,0,
1,74,543,1,73,
568,19,569,4,16,
82,0,101,0,99,
0,111,0,114,0,
100,0,84,0,121,
0,1,73,543,1,
72,570,19,571,4,
12,78,0,97,0,
109,0,101,0,84,
0,121,0,1,72,
543,1,71,572,19,
168,1,71,543,1,
70,573,19,146,1,
70,528,1,69,574,
19,575,4,14,84,
0,121,0,112,0,
101,0,68,0,101,
0,99,0,1,69,
513,1,68,576,19,
577,4,12,86,0,
97,0,114,0,68,
0,101,0,99,0,
1,68,513,1,67,
578,19,579,4,22,
70,0,117,0,110,
0,99,0,116,0,
105,0,111,0,110,
0,68,0,101,0,
99,0,1,67,513,
1,66,580,19,312,
1,66,513,1,65,
581,19,582,4,16,
65,0,114,0,114,
0,97,0,121,0,
69,0,120,0,112,
0,1,65,349,1,
64,583,19,584,4,
12,76,0,101,0,
116,0,69,0,120,
0,112,0,1,64,
349,1,63,585,19,
586,4,16,66,0,
114,0,101,0,97,
0,107,0,69,0,
120,0,112,0,1,
63,349,1,62,587,
19,588,4,12,70,
0,111,0,114,0,
69,0,120,0,112,
0,1,62,349,1,
61,589,19,590,4,
16,87,0,104,0,
105,0,108,0,101,
0,69,0,120,0,
112,0,1,61,349,
1,60,591,19,592,
4,10,73,0,102,
0,69,0,120,0,
112,0,1,60,349,
1,59,593,19,594,
4,18,65,0,115,
0,115,0,105,0,
103,0,110,0,69,
0,120,0,112,0,
1,59,349,1,58,
595,19,596,4,12,
83,0,101,0,113,
0,69,0,120,0,
112,0,1,58,349,
1,57,597,19,598,
4,18,82,0,101,
0,99,0,111,0,
114,0,100,0,69,
0,120,0,112,0,
1,57,349,1,56,
599,19,600,4,10,
79,0,112,0,69,
0,120,0,112,0,
1,56,349,1,55,
601,19,602,4,14,
67,0,97,0,108,
0,108,0,69,0,
120,0,112,0,1,
55,349,1,54,603,
19,604,4,18,83,
0,116,0,114,0,
105,0,110,0,103,
0,69,0,120,0,
112,0,1,54,349,
1,53,605,19,606,
4,12,73,0,110,
0,116,0,69,0,
120,0,112,0,1,
53,349,1,52,607,
19,608,4,12,78,
0,105,0,108,0,
69,0,120,0,112,
0,1,52,349,1,
51,609,19,610,4,
12,86,0,97,0,
114,0,69,0,120,
0,112,0,1,51,
349,1,50,611,19,
103,1,50,349,1,
49,612,19,613,4,
24,83,0,117,0,
98,0,115,0,99,
0,114,0,105,0,
112,0,116,0,86,
0,97,0,114,0,
1,49,470,1,48,
614,19,615,4,16,
70,0,105,0,101,
0,108,0,100,0,
86,0,97,0,114,
0,1,48,470,1,
47,616,19,617,4,
18,83,0,105,0,
109,0,112,0,108,
0,101,0,86,0,
97,0,114,0,1,
47,470,1,46,618,
19,252,1,46,470,
1,45,619,19,127,
1,45,620,5,48,
1,424,621,17,622,
15,623,4,16,37,
0,67,0,97,0,
108,0,108,0,69,
0,120,0,112,0,
1,-1,1,5,624,
20,431,1,113,1,
3,1,4,1,3,
625,22,1,33,1,
423,626,17,627,15,
623,1,-1,1,5,
628,20,429,1,114,
1,3,1,5,1,
4,629,22,1,34,
1,300,630,17,631,
15,632,4,14,37,
0,78,0,105,0,
108,0,69,0,120,
0,112,0,1,-1,
1,5,633,20,443,
1,107,1,3,1,
2,1,1,634,22,
1,27,1,308,635,
17,636,15,637,4,
14,37,0,83,0,
101,0,113,0,69,
0,120,0,112,0,
1,-1,1,5,638,
20,441,1,108,1,
3,1,3,1,2,
639,22,1,28,1,
306,640,17,641,15,
637,1,-1,1,5,
642,20,439,1,109,
1,3,1,4,1,
3,643,22,1,29,
1,519,644,17,645,
15,646,4,12,37,
0,79,0,112,0,
69,0,120,0,112,
0,1,-1,1,5,
647,20,409,1,124,
1,3,1,4,1,
3,648,22,1,44,
1,517,649,17,650,
15,651,4,18,37,
0,70,0,105,0,
101,0,108,0,100,
0,86,0,97,0,
114,0,1,-1,1,
5,652,20,508,1,
98,1,3,1,4,
1,3,653,22,1,
18,1,87,654,17,
655,15,656,4,20,
37,0,82,0,101,
0,99,0,111,0,
114,0,100,0,69,
0,120,0,112,0,
1,-1,1,5,657,
20,403,1,127,1,
3,1,5,1,4,
658,22,1,47,1,
728,659,17,660,15,
661,4,14,37,0,
68,0,101,0,99,
0,86,0,97,0,
114,0,1,-1,1,
5,662,20,527,1,
90,1,3,1,6,
1,5,663,22,1,
10,1,84,664,17,
665,15,666,4,20,
37,0,83,0,105,
0,109,0,112,0,
108,0,101,0,86,
0,97,0,114,0,
1,-1,1,5,667,
20,510,1,97,1,
3,1,2,1,1,
668,22,1,17,1,
190,669,17,670,15,
646,1,-1,1,5,
671,20,423,1,117,
1,3,1,4,1,
3,672,22,1,37,
1,595,673,17,674,
15,675,4,12,37,
0,73,0,102,0,
69,0,120,0,112,
0,1,-1,1,5,
676,20,407,1,125,
1,3,1,4,1,
3,677,22,1,45,
1,73,678,17,679,
15,680,4,20,37,
0,65,0,115,0,
115,0,105,0,103,
0,110,0,69,0,
120,0,112,0,1,
-1,1,5,681,20,
399,1,129,1,3,
1,4,1,3,682,
22,1,49,1,822,
683,17,684,15,685,
4,24,37,0,70,
0,117,0,110,0,
99,0,116,0,105,
0,111,0,110,0,
68,0,101,0,99,
0,1,-1,1,5,
686,20,517,1,95,
1,3,1,7,1,
6,687,22,1,15,
1,264,688,17,689,
15,690,4,20,37,
0,83,0,116,0,
114,0,105,0,110,
0,103,0,69,0,
120,0,112,0,1,
-1,1,5,691,20,
435,1,111,1,3,
1,2,1,1,692,
22,1,31,1,479,
693,17,694,15,695,
4,18,37,0,65,
0,114,0,114,0,
97,0,121,0,69,
0,120,0,112,0,
1,-1,1,5,696,
20,401,1,128,1,
3,1,7,1,6,
697,22,1,48,1,
66,698,17,699,15,
700,4,14,37,0,
86,0,97,0,114,
0,69,0,120,0,
112,0,1,-1,1,
5,701,20,445,1,
106,1,3,1,2,
1,1,702,22,1,
26,1,172,703,17,
704,15,646,1,-1,
1,5,705,20,421,
1,118,1,3,1,
4,1,3,706,22,
1,38,1,57,707,
17,708,15,675,1,
-1,1,5,709,20,
397,1,130,1,3,
1,7,1,6,710,
22,1,50,1,918,
711,16,0,125,1,
916,712,17,713,15,
714,4,14,37,0,
86,0,97,0,114,
0,68,0,101,0,
99,0,1,-1,1,
5,715,20,525,1,
91,1,3,1,3,
1,2,716,22,1,
11,1,914,717,17,
718,15,719,4,14,
37,0,78,0,97,
0,109,0,101,0,
84,0,121,0,1,
-1,1,5,720,20,
550,1,83,1,3,
1,2,1,1,721,
22,1,3,1,913,
722,17,723,15,724,
4,18,37,0,82,
0,101,0,99,0,
111,0,114,0,100,
0,84,0,121,0,
1,-1,1,5,725,
20,548,1,84,1,
3,1,3,1,2,
726,22,1,4,1,
912,727,17,728,15,
724,1,-1,1,5,
729,20,546,1,85,
1,3,1,4,1,
3,730,22,1,5,
1,908,731,17,732,
15,733,4,16,37,
0,65,0,114,0,
114,0,97,0,121,
0,84,0,121,0,
1,-1,1,5,734,
20,542,1,86,1,
3,1,4,1,3,
735,22,1,6,1,
265,736,17,737,15,
738,4,14,37,0,
73,0,110,0,116,
0,69,0,120,0,
112,0,1,-1,1,
5,739,20,437,1,
110,1,3,1,2,
1,1,740,22,1,
30,1,50,741,17,
742,15,675,1,-1,
1,5,743,20,395,
1,131,1,3,1,
5,1,4,744,22,
1,51,1,905,745,
17,746,15,747,4,
16,37,0,84,0,
121,0,112,0,101,
0,68,0,101,0,
99,0,1,-1,1,
5,748,20,523,1,
92,1,3,1,5,
1,4,749,22,1,
12,1,155,750,17,
751,15,646,1,-1,
1,5,752,20,419,
1,119,1,3,1,
4,1,3,753,22,
1,39,1,796,754,
17,755,15,685,1,
-1,1,5,756,20,
512,1,96,1,3,
1,9,1,8,757,
22,1,16,1,471,
758,17,759,15,760,
4,26,37,0,83,
0,117,0,98,0,
115,0,99,0,114,
0,105,0,112,0,
116,0,86,0,97,
0,114,0,1,-1,
1,5,761,20,469,
1,99,1,3,1,
5,1,4,762,22,
1,19,1,250,763,
17,764,15,646,1,
-1,1,5,765,20,
433,1,112,1,3,
1,3,1,2,766,
22,1,32,1,32,
767,17,768,15,769,
4,18,37,0,87,
0,104,0,105,0,
108,0,101,0,69,
0,120,0,112,0,
1,-1,1,5,770,
20,393,1,132,1,
3,1,5,1,4,
771,22,1,52,1,
139,772,17,773,15,
646,1,-1,1,5,
774,20,417,1,120,
1,3,1,4,1,
3,775,22,1,40,
1,852,776,17,777,
15,685,1,-1,1,
5,778,20,519,1,
94,1,3,1,10,
1,9,779,22,1,
14,1,878,780,17,
781,15,685,1,-1,
1,5,782,20,521,
1,93,1,3,1,
8,1,7,783,22,
1,13,1,18,784,
17,785,15,786,4,
14,37,0,70,0,
111,0,114,0,69,
0,120,0,112,0,
1,-1,1,5,787,
20,391,1,133,1,
3,1,7,1,6,
788,22,1,53,1,
124,789,17,790,15,
646,1,-1,1,5,
791,20,415,1,121,
1,3,1,4,1,
3,792,22,1,41,
1,229,793,17,794,
15,646,1,-1,1,
5,795,20,427,1,
115,1,3,1,4,
1,3,796,22,1,
35,1,656,797,17,
798,15,675,1,-1,
1,5,799,20,405,
1,126,1,3,1,
4,1,3,800,22,
1,46,1,209,801,
17,802,15,646,1,
-1,1,5,803,20,
425,1,116,1,3,
1,4,1,3,804,
22,1,36,1,5,
805,17,806,15,807,
4,14,37,0,76,
0,101,0,116,0,
69,0,120,0,112,
0,1,-1,1,5,
808,20,348,1,136,
1,3,1,6,1,
5,809,22,1,56,
1,8,810,17,811,
15,812,4,18,37,
0,66,0,114,0,
101,0,97,0,107,
0,69,0,120,0,
112,0,1,-1,1,
5,813,20,389,1,
134,1,3,1,2,
1,1,814,22,1,
54,1,7,815,17,
816,15,807,1,-1,
1,5,817,20,387,
1,135,1,3,1,
5,1,4,818,22,
1,55,1,754,819,
17,820,15,661,1,
-1,1,5,821,20,
532,1,89,1,3,
1,4,1,3,822,
22,1,9,1,110,
823,17,824,15,646,
1,-1,1,5,825,
20,413,1,122,1,
3,1,4,1,3,
826,22,1,42,1,
430,827,17,828,15,
646,1,-1,1,5,
829,20,411,1,123,
1,3,1,4,1,
3,830,22,1,43,
1,1,831,16,0,
125,1,44,832,19,
149,1,44,833,5,
48,1,424,621,1,
423,626,1,300,630,
1,308,635,1,306,
640,1,519,644,1,
517,649,1,87,654,
1,728,659,1,84,
664,1,190,669,1,
595,673,1,73,678,
1,822,683,1,264,
688,1,479,693,1,
66,698,1,172,703,
1,57,707,1,918,
834,16,0,147,1,
916,712,1,914,717,
1,913,722,1,912,
727,1,908,731,1,
265,736,1,50,741,
1,905,745,1,155,
750,1,796,754,1,
471,758,1,250,763,
1,32,767,1,139,
772,1,852,776,1,
878,780,1,18,784,
1,124,789,1,229,
793,1,656,797,1,
209,801,1,5,805,
1,8,810,1,7,
815,1,754,819,1,
110,823,1,430,827,
1,1,835,16,0,
147,1,43,836,19,
255,1,43,837,5,
48,1,424,621,1,
423,626,1,300,630,
1,308,635,1,306,
640,1,519,644,1,
517,649,1,87,654,
1,728,659,1,84,
664,1,190,669,1,
595,673,1,73,678,
1,822,683,1,264,
688,1,479,693,1,
66,698,1,172,703,
1,57,707,1,918,
838,16,0,253,1,
916,712,1,914,717,
1,913,722,1,912,
727,1,908,731,1,
265,736,1,50,741,
1,905,745,1,155,
750,1,796,754,1,
471,758,1,250,763,
1,32,767,1,139,
772,1,852,776,1,
878,780,1,18,784,
1,124,789,1,229,
793,1,656,797,1,
209,801,1,5,805,
1,8,810,1,7,
815,1,754,819,1,
110,823,1,430,827,
1,1,839,16,0,
253,1,42,840,19,
259,1,42,841,5,
36,1,746,842,16,
0,257,1,102,843,
16,0,257,1,844,
844,16,0,257,1,
201,845,16,0,257,
1,814,846,16,0,
257,1,89,847,16,
0,257,1,407,848,
16,0,257,1,720,
849,16,0,257,1,
77,850,16,0,257,
1,182,851,16,0,
257,1,287,852,16,
0,257,1,67,853,
16,0,257,1,386,
854,16,0,257,1,
60,855,16,0,257,
1,164,856,16,0,
257,1,266,857,16,
0,257,1,51,858,
16,0,257,1,45,
859,16,0,257,1,
472,860,16,0,257,
1,39,861,16,0,
257,1,147,862,16,
0,257,1,788,863,
16,0,257,1,463,
864,16,0,257,1,
34,865,16,0,257,
1,28,866,16,0,
257,1,242,867,16,
0,257,1,131,868,
16,0,257,1,23,
869,16,0,257,1,
19,870,16,0,257,
1,15,871,16,0,
257,1,870,872,16,
0,257,1,11,873,
16,0,257,1,116,
874,16,0,257,1,
221,875,16,0,257,
1,3,876,16,0,
257,1,0,877,16,
0,257,1,41,878,
19,331,1,41,879,
5,36,1,746,880,
16,0,329,1,102,
881,16,0,329,1,
844,882,16,0,329,
1,201,883,16,0,
329,1,814,884,16,
0,329,1,89,885,
16,0,329,1,407,
886,16,0,329,1,
720,887,16,0,329,
1,77,888,16,0,
329,1,182,889,16,
0,329,1,287,890,
16,0,329,1,67,
891,16,0,329,1,
386,892,16,0,329,
1,60,893,16,0,
329,1,164,894,16,
0,329,1,266,895,
16,0,329,1,51,
896,16,0,329,1,
45,897,16,0,329,
1,472,898,16,0,
329,1,39,899,16,
0,329,1,147,900,
16,0,329,1,788,
901,16,0,329,1,
463,902,16,0,329,
1,34,903,16,0,
329,1,28,904,16,
0,329,1,242,905,
16,0,329,1,131,
906,16,0,329,1,
23,907,16,0,329,
1,19,908,16,0,
329,1,15,909,16,
0,329,1,870,910,
16,0,329,1,11,
911,16,0,329,1,
116,912,16,0,329,
1,221,913,16,0,
329,1,3,914,16,
0,329,1,0,915,
16,0,329,1,40,
916,19,108,1,40,
917,5,2,1,471,
918,16,0,106,1,
906,919,16,0,123,
1,39,920,19,334,
1,39,921,5,38,
1,424,621,1,423,
626,1,87,654,1,
308,635,1,306,640,
1,519,644,1,517,
649,1,301,922,17,
923,15,924,4,16,
37,0,69,0,120,
0,112,0,76,0,
105,0,115,0,116,
0,1,-1,1,5,
925,20,461,1,101,
1,3,1,4,1,
3,926,22,1,21,
1,300,630,1,84,
664,1,190,669,1,
274,927,17,928,15,
924,1,-1,1,5,
929,20,467,1,100,
1,3,1,2,1,
1,930,22,1,20,
1,73,678,1,264,
688,1,66,698,1,
172,703,1,265,736,
1,595,673,1,57,
707,1,479,693,1,
50,741,1,155,750,
1,471,758,1,139,
772,1,250,763,1,
32,767,1,18,784,
1,124,789,1,229,
793,1,656,797,1,
209,801,1,3,931,
16,0,332,1,8,
810,1,7,815,1,
5,805,1,4,932,
16,0,335,1,110,
823,1,430,827,1,
38,933,19,339,1,
38,934,5,50,1,
424,621,1,423,626,
1,308,635,1,306,
640,1,519,644,1,
264,688,1,517,649,
1,87,654,1,300,
630,1,84,664,1,
190,669,1,595,673,
1,73,678,1,822,
683,1,66,698,1,
479,693,1,922,935,
17,936,15,937,4,
16,37,0,68,0,
101,0,99,0,76,
0,105,0,115,0,
116,0,1,-1,1,
5,938,20,552,1,
82,1,3,1,3,
1,2,939,22,1,
2,1,172,703,1,
57,707,1,918,940,
17,941,15,942,4,
10,37,0,110,0,
117,0,108,0,108,
0,1,-1,1,5,
943,20,557,1,81,
1,3,1,1,1,
0,944,22,1,1,
1,916,712,1,914,
717,1,913,722,1,
912,727,1,908,731,
1,265,736,1,50,
741,1,905,745,1,
155,750,1,796,754,
1,471,758,1,250,
763,1,32,767,1,
139,772,1,728,659,
1,852,776,1,878,
780,1,18,784,1,
124,789,1,229,793,
1,656,797,1,209,
801,1,5,805,1,
8,810,1,7,815,
1,754,819,1,2,
945,16,0,337,1,
110,823,1,430,827,
1,1,946,17,941,
1,0,944,1,37,
947,19,343,1,37,
948,5,36,1,746,
949,16,0,341,1,
102,950,16,0,341,
1,844,951,16,0,
341,1,201,952,16,
0,341,1,814,953,
16,0,341,1,89,
954,16,0,341,1,
407,955,16,0,341,
1,720,956,16,0,
341,1,77,957,16,
0,341,1,182,958,
16,0,341,1,287,
959,16,0,341,1,
67,960,16,0,341,
1,386,961,16,0,
341,1,60,962,16,
0,341,1,164,963,
16,0,341,1,266,
964,16,0,341,1,
51,965,16,0,341,
1,45,966,16,0,
341,1,472,967,16,
0,341,1,39,968,
16,0,341,1,147,
969,16,0,341,1,
788,970,16,0,341,
1,463,971,16,0,
341,1,34,972,16,
0,341,1,28,973,
16,0,341,1,242,
974,16,0,341,1,
131,975,16,0,341,
1,23,976,16,0,
341,1,19,977,16,
0,341,1,15,978,
16,0,341,1,870,
979,16,0,341,1,
11,980,16,0,341,
1,116,981,16,0,
341,1,221,982,16,
0,341,1,3,983,
16,0,341,1,0,
984,16,0,341,1,
36,985,19,298,1,
36,986,5,36,1,
424,621,1,423,626,
1,308,635,1,306,
640,1,519,644,1,
517,649,1,87,654,
1,300,630,1,84,
664,1,190,669,1,
73,678,1,264,688,
1,66,698,1,172,
703,1,265,736,1,
595,673,1,57,707,
1,479,693,1,50,
741,1,155,750,1,
471,758,1,139,772,
1,250,763,1,32,
767,1,27,987,16,
0,296,1,18,784,
1,124,789,1,14,
988,16,0,319,1,
229,793,1,656,797,
1,209,801,1,8,
810,1,7,815,1,
5,805,1,110,823,
1,430,827,1,35,
989,19,324,1,35,
990,5,37,1,424,
621,1,423,626,1,
300,630,1,308,635,
1,306,640,1,519,
644,1,517,649,1,
87,654,1,728,659,
1,84,664,1,190,
669,1,73,678,1,
264,688,1,66,698,
1,172,703,1,265,
736,1,595,673,1,
57,707,1,479,693,
1,50,741,1,155,
750,1,471,758,1,
139,772,1,250,763,
1,32,767,1,18,
784,1,124,789,1,
229,793,1,656,797,
1,209,801,1,10,
991,16,0,322,1,
5,805,1,8,810,
1,7,815,1,754,
819,1,110,823,1,
430,827,1,34,992,
19,328,1,34,993,
5,36,1,746,994,
16,0,326,1,102,
995,16,0,326,1,
844,996,16,0,326,
1,201,997,16,0,
326,1,814,998,16,
0,326,1,89,999,
16,0,326,1,407,
1000,16,0,326,1,
720,1001,16,0,326,
1,77,1002,16,0,
326,1,182,1003,16,
0,326,1,287,1004,
16,0,326,1,67,
1005,16,0,326,1,
386,1006,16,0,326,
1,60,1007,16,0,
326,1,164,1008,16,
0,326,1,266,1009,
16,0,326,1,51,
1010,16,0,326,1,
45,1011,16,0,326,
1,472,1012,16,0,
326,1,39,1013,16,
0,326,1,147,1014,
16,0,326,1,788,
1015,16,0,326,1,
463,1016,16,0,326,
1,34,1017,16,0,
326,1,28,1018,16,
0,326,1,242,1019,
16,0,326,1,131,
1020,16,0,326,1,
23,1021,16,0,326,
1,19,1022,16,0,
326,1,15,1023,16,
0,326,1,870,1024,
16,0,326,1,11,
1025,16,0,326,1,
116,1026,16,0,326,
1,221,1027,16,0,
326,1,3,1028,16,
0,326,1,0,1029,
16,0,326,1,33,
1030,19,309,1,33,
1031,5,36,1,746,
1032,16,0,307,1,
102,1033,16,0,307,
1,844,1034,16,0,
307,1,201,1035,16,
0,307,1,814,1036,
16,0,307,1,89,
1037,16,0,307,1,
407,1038,16,0,307,
1,720,1039,16,0,
307,1,77,1040,16,
0,307,1,182,1041,
16,0,307,1,287,
1042,16,0,307,1,
67,1043,16,0,307,
1,386,1044,16,0,
307,1,60,1045,16,
0,307,1,164,1046,
16,0,307,1,266,
1047,16,0,307,1,
51,1048,16,0,307,
1,45,1049,16,0,
307,1,472,1050,16,
0,307,1,39,1051,
16,0,307,1,147,
1052,16,0,307,1,
788,1053,16,0,307,
1,463,1054,16,0,
307,1,34,1055,16,
0,307,1,28,1056,
16,0,307,1,242,
1057,16,0,307,1,
131,1058,16,0,307,
1,23,1059,16,0,
307,1,19,1060,16,
0,307,1,15,1061,
16,0,307,1,870,
1062,16,0,307,1,
11,1063,16,0,307,
1,116,1064,16,0,
307,1,221,1065,16,
0,307,1,3,1066,
16,0,307,1,0,
1067,16,0,307,1,
32,1068,19,267,1,
32,1069,5,34,1,
424,621,1,423,626,
1,308,635,1,306,
640,1,519,644,1,
517,649,1,87,654,
1,300,630,1,84,
664,1,190,669,1,
73,678,1,264,688,
1,66,698,1,172,
703,1,265,736,1,
595,673,1,57,707,
1,479,693,1,50,
1070,16,0,265,1,
155,750,1,471,758,
1,139,772,1,250,
763,1,32,767,1,
18,784,1,124,789,
1,229,793,1,656,
797,1,209,801,1,
8,810,1,7,815,
1,5,805,1,110,
823,1,430,827,1,
31,1071,19,275,1,
31,1072,5,35,1,
424,621,1,423,626,
1,308,635,1,306,
640,1,519,644,1,
517,649,1,87,654,
1,300,630,1,84,
664,1,190,669,1,
73,678,1,264,688,
1,66,698,1,172,
703,1,265,736,1,
595,673,1,57,707,
1,479,693,1,50,
741,1,155,750,1,
44,1073,16,0,273,
1,471,758,1,139,
772,1,250,763,1,
32,767,1,18,784,
1,124,789,1,229,
793,1,656,797,1,
209,801,1,8,810,
1,7,815,1,5,
805,1,110,823,1,
430,827,1,30,1074,
19,284,1,30,1075,
5,36,1,746,1076,
16,0,282,1,102,
1077,16,0,282,1,
844,1078,16,0,282,
1,201,1079,16,0,
282,1,814,1080,16,
0,282,1,89,1081,
16,0,282,1,407,
1082,16,0,282,1,
720,1083,16,0,282,
1,77,1084,16,0,
282,1,182,1085,16,
0,282,1,287,1086,
16,0,282,1,67,
1087,16,0,282,1,
386,1088,16,0,282,
1,60,1089,16,0,
282,1,164,1090,16,
0,282,1,266,1091,
16,0,282,1,51,
1092,16,0,282,1,
45,1093,16,0,282,
1,472,1094,16,0,
282,1,39,1095,16,
0,282,1,147,1096,
16,0,282,1,788,
1097,16,0,282,1,
463,1098,16,0,282,
1,34,1099,16,0,
282,1,28,1100,16,
0,282,1,242,1101,
16,0,282,1,131,
1102,16,0,282,1,
23,1103,16,0,282,
1,19,1104,16,0,
282,1,15,1105,16,
0,282,1,870,1106,
16,0,282,1,11,
1107,16,0,282,1,
116,1108,16,0,282,
1,221,1109,16,0,
282,1,3,1110,16,
0,282,1,0,1111,
16,0,282,1,29,
1112,19,281,1,29,
1113,5,1,1,904,
1114,16,0,279,1,
28,1115,19,213,1,
28,1116,5,6,1,
471,758,1,66,1117,
16,0,249,1,84,
664,1,719,1118,16,
0,211,1,717,1119,
16,0,295,1,517,
649,1,27,1120,19,
316,1,27,1121,5,
48,1,852,1122,16,
0,314,1,423,626,
1,822,1123,16,0,
314,1,97,1124,16,
0,314,1,308,635,
1,306,640,1,519,
644,1,517,649,1,
87,654,1,728,1125,
16,0,314,1,84,
664,1,190,669,1,
264,688,1,73,1126,
16,0,314,1,930,
1127,16,0,314,1,
394,1128,16,0,314,
1,274,1129,16,0,
314,1,479,1130,16,
0,314,1,66,698,
1,172,703,1,595,
673,1,57,1131,16,
0,314,1,265,736,
1,50,1132,16,0,
314,1,155,750,1,
796,1133,16,0,314,
1,44,1134,16,0,
314,1,471,758,1,
470,1135,16,0,314,
1,250,763,1,32,
1136,16,0,314,1,
139,772,1,27,1137,
16,0,314,1,878,
1138,16,0,314,1,
18,1139,16,0,314,
1,124,789,1,14,
1140,16,0,314,1,
229,793,1,656,797,
1,424,621,1,8,
810,1,5,805,1,
110,823,1,7,815,
1,754,1141,16,0,
314,1,209,801,1,
430,827,1,300,630,
1,26,1142,19,292,
1,26,1143,5,48,
1,852,1144,16,0,
290,1,423,626,1,
822,1145,16,0,290,
1,97,1146,16,0,
290,1,308,635,1,
306,640,1,519,644,
1,517,649,1,87,
654,1,728,1147,16,
0,290,1,84,664,
1,190,669,1,264,
688,1,73,1148,16,
0,290,1,930,1149,
16,0,290,1,394,
1150,16,0,290,1,
274,1151,16,0,290,
1,479,1152,16,0,
290,1,66,698,1,
172,703,1,595,673,
1,57,1153,16,0,
290,1,265,736,1,
50,1154,16,0,290,
1,155,750,1,796,
1155,16,0,290,1,
44,1156,16,0,290,
1,471,758,1,470,
1157,16,0,290,1,
250,763,1,32,1158,
16,0,290,1,139,
772,1,27,1159,16,
0,290,1,878,1160,
16,0,290,1,18,
1161,16,0,290,1,
124,789,1,14,1162,
16,0,290,1,229,
793,1,656,797,1,
424,621,1,8,810,
1,5,805,1,110,
823,1,7,815,1,
754,1163,16,0,290,
1,209,801,1,430,
827,1,300,630,1,
25,1164,19,262,1,
25,1165,5,29,1,
796,1166,16,0,260,
1,87,654,1,274,
1167,16,0,260,1,
84,664,1,878,1168,
16,0,260,1,265,
736,1,300,630,1,
27,1169,16,0,260,
1,308,635,1,728,
1170,16,0,260,1,
306,640,1,822,1171,
16,0,260,1,930,
1172,16,0,260,1,
66,698,1,394,1173,
16,0,260,1,471,
758,1,470,1174,16,
0,260,1,423,626,
1,14,1175,16,0,
260,1,264,688,1,
44,1176,16,0,260,
1,8,810,1,7,
815,1,852,1177,16,
0,260,1,5,805,
1,97,1178,16,0,
260,1,754,1179,16,
0,260,1,424,621,
1,517,649,1,24,
1180,19,241,1,24,
1181,5,29,1,796,
1182,16,0,239,1,
87,654,1,274,1183,
16,0,239,1,84,
664,1,878,1184,16,
0,239,1,265,736,
1,300,630,1,27,
1185,16,0,239,1,
308,635,1,728,1186,
16,0,239,1,306,
640,1,822,1187,16,
0,239,1,930,1188,
16,0,239,1,66,
698,1,394,1189,16,
0,239,1,471,758,
1,470,1190,16,0,
239,1,423,626,1,
14,1191,16,0,239,
1,264,688,1,44,
1192,16,0,239,1,
8,810,1,7,815,
1,852,1193,16,0,
239,1,5,805,1,
97,1194,16,0,239,
1,754,1195,16,0,
239,1,424,621,1,
517,649,1,23,1196,
19,223,1,23,1197,
5,29,1,796,1198,
16,0,221,1,87,
654,1,274,1199,16,
0,221,1,84,664,
1,878,1200,16,0,
221,1,265,736,1,
300,630,1,27,1201,
16,0,221,1,308,
635,1,728,1202,16,
0,221,1,306,640,
1,822,1203,16,0,
221,1,930,1204,16,
0,221,1,66,698,
1,394,1205,16,0,
221,1,471,758,1,
470,1206,16,0,221,
1,423,626,1,14,
1207,16,0,221,1,
264,688,1,44,1208,
16,0,221,1,8,
810,1,7,815,1,
852,1209,16,0,221,
1,5,805,1,97,
1210,16,0,221,1,
754,1211,16,0,221,
1,424,621,1,517,
649,1,22,1212,19,
217,1,22,1213,5,
29,1,796,1214,16,
0,215,1,87,654,
1,274,1215,16,0,
215,1,84,664,1,
878,1216,16,0,215,
1,265,736,1,300,
630,1,27,1217,16,
0,215,1,308,635,
1,728,1218,16,0,
215,1,306,640,1,
822,1219,16,0,215,
1,930,1220,16,0,
215,1,66,698,1,
394,1221,16,0,215,
1,471,758,1,470,
1222,16,0,215,1,
423,626,1,14,1223,
16,0,215,1,264,
688,1,44,1224,16,
0,215,1,8,810,
1,7,815,1,852,
1225,16,0,215,1,
5,805,1,97,1226,
16,0,215,1,754,
1227,16,0,215,1,
424,621,1,517,649,
1,21,1228,19,206,
1,21,1229,5,29,
1,796,1230,16,0,
204,1,87,654,1,
274,1231,16,0,204,
1,84,664,1,878,
1232,16,0,204,1,
265,736,1,300,630,
1,27,1233,16,0,
204,1,308,635,1,
728,1234,16,0,204,
1,306,640,1,822,
1235,16,0,204,1,
930,1236,16,0,204,
1,66,698,1,394,
1237,16,0,204,1,
471,758,1,470,1238,
16,0,204,1,423,
626,1,14,1239,16,
0,204,1,264,688,
1,44,1240,16,0,
204,1,8,810,1,
7,815,1,852,1241,
16,0,204,1,5,
805,1,97,1242,16,
0,204,1,754,1243,
16,0,204,1,424,
621,1,517,649,1,
20,1244,19,171,1,
20,1245,5,35,1,
424,621,1,423,626,
1,822,1246,16,0,
198,1,796,1247,16,
0,198,1,97,1248,
16,0,198,1,308,
635,1,306,640,1,
517,649,1,88,1249,
16,0,231,1,87,
654,1,728,1250,16,
0,198,1,84,664,
1,930,1251,16,0,
198,1,394,1252,16,
0,198,1,66,698,
1,274,1253,16,0,
198,1,265,736,1,
264,688,1,903,1254,
16,0,169,1,44,
1255,16,0,198,1,
471,758,1,470,1256,
16,0,198,1,787,
1257,16,0,245,1,
785,1258,16,0,197,
1,27,1259,16,0,
198,1,852,1260,16,
0,198,1,878,1261,
16,0,198,1,843,
1262,16,0,207,1,
14,1263,16,0,198,
1,841,1264,16,0,
195,1,5,805,1,
8,810,1,7,815,
1,754,1265,16,0,
198,1,300,630,1,
19,1266,19,190,1,
19,1267,5,48,1,
852,1268,16,0,188,
1,423,626,1,822,
1269,16,0,188,1,
97,1270,16,0,188,
1,308,635,1,306,
640,1,519,1271,16,
0,188,1,517,649,
1,87,654,1,728,
1272,16,0,188,1,
84,664,1,190,669,
1,264,688,1,73,
1273,16,0,188,1,
930,1274,16,0,188,
1,394,1275,16,0,
188,1,274,1276,16,
0,188,1,479,1277,
16,0,188,1,66,
698,1,172,703,1,
595,1278,16,0,188,
1,57,1279,16,0,
188,1,265,736,1,
50,1280,16,0,188,
1,155,1281,16,0,
188,1,796,1282,16,
0,188,1,44,1283,
16,0,188,1,471,
758,1,470,1284,16,
0,188,1,250,763,
1,32,1285,16,0,
188,1,139,1286,16,
0,188,1,27,1287,
16,0,188,1,878,
1288,16,0,188,1,
18,1289,16,0,188,
1,124,1290,16,0,
188,1,14,1291,16,
0,188,1,229,1292,
16,0,188,1,656,
1293,16,0,188,1,
424,621,1,8,810,
1,5,805,1,110,
1294,16,0,188,1,
7,815,1,754,1295,
16,0,188,1,209,
1296,16,0,188,1,
430,1297,16,0,188,
1,300,630,1,18,
1298,19,165,1,18,
1299,5,48,1,852,
1300,16,0,163,1,
423,626,1,822,1301,
16,0,163,1,97,
1302,16,0,163,1,
308,635,1,306,640,
1,519,1303,16,0,
163,1,517,649,1,
87,654,1,728,1304,
16,0,163,1,84,
664,1,190,669,1,
264,688,1,73,1305,
16,0,163,1,930,
1306,16,0,163,1,
394,1307,16,0,163,
1,274,1308,16,0,
163,1,479,1309,16,
0,163,1,66,698,
1,172,703,1,595,
1310,16,0,163,1,
57,1311,16,0,163,
1,265,736,1,50,
1312,16,0,163,1,
155,1313,16,0,163,
1,796,1314,16,0,
163,1,44,1315,16,
0,163,1,471,758,
1,470,1316,16,0,
163,1,250,763,1,
32,1317,16,0,163,
1,139,1318,16,0,
163,1,27,1319,16,
0,163,1,878,1320,
16,0,163,1,18,
1321,16,0,163,1,
124,1322,16,0,163,
1,14,1323,16,0,
163,1,229,1324,16,
0,163,1,656,1325,
16,0,163,1,424,
621,1,8,810,1,
5,805,1,110,1326,
16,0,163,1,7,
815,1,754,1327,16,
0,163,1,209,1328,
16,0,163,1,430,
1329,16,0,163,1,
300,630,1,17,1330,
19,143,1,17,1331,
5,84,1,472,1332,
16,0,321,1,471,
758,1,470,1333,16,
0,141,1,229,793,
1,463,1334,16,0,
321,1,221,1335,16,
0,321,1,930,1336,
16,0,141,1,209,
801,1,201,1337,16,
0,321,1,430,1338,
16,0,141,1,190,
669,1,424,621,1,
423,626,1,182,1339,
16,0,321,1,656,
1340,16,0,141,1,
386,1341,16,0,321,
1,172,703,1,394,
1342,16,0,141,1,
407,1343,16,0,321,
1,164,1344,16,0,
321,1,878,1345,16,
0,141,1,155,1346,
16,0,141,1,870,
1347,16,0,321,1,
147,1348,16,0,321,
1,139,1349,16,0,
141,1,852,1350,16,
0,141,1,131,1351,
16,0,321,1,844,
1352,16,0,321,1,
124,1353,16,0,141,
1,595,1354,16,0,
141,1,116,1355,16,
0,321,1,110,1356,
16,0,141,1,97,
1357,16,0,141,1,
822,1358,16,0,141,
1,102,1359,16,0,
321,1,814,1360,16,
0,321,1,89,1361,
16,0,321,1,87,
654,1,84,664,1,
796,1362,16,0,141,
1,77,1363,16,0,
321,1,67,1364,16,
0,321,1,73,1365,
16,0,141,1,788,
1366,16,0,321,1,
308,635,1,306,640,
1,66,698,1,300,
630,1,60,1367,16,
0,321,1,57,1368,
16,0,141,1,51,
1369,16,0,321,1,
50,1370,16,0,141,
1,287,1371,16,0,
321,1,266,1372,16,
0,321,1,45,1373,
16,0,321,1,44,
1374,16,0,141,1,
39,1375,16,0,321,
1,519,1376,16,0,
141,1,517,649,1,
754,1377,16,0,141,
1,274,1378,16,0,
141,1,34,1379,16,
0,321,1,32,1380,
16,0,141,1,746,
1381,16,0,321,1,
28,1382,16,0,321,
1,27,1383,16,0,
141,1,265,736,1,
264,688,1,23,1384,
16,0,321,1,250,
763,1,19,1385,16,
0,321,1,18,1386,
16,0,141,1,15,
1387,16,0,321,1,
14,1388,16,0,141,
1,11,1389,16,0,
321,1,242,1390,16,
0,321,1,728,1391,
16,0,141,1,3,
1392,16,0,321,1,
8,810,1,7,815,
1,5,805,1,720,
1393,16,0,321,1,
479,1394,16,0,141,
1,0,1395,16,0,
321,1,16,1396,19,
122,1,16,1397,5,
48,1,852,1398,16,
0,120,1,423,626,
1,822,1399,16,0,
120,1,97,1400,16,
0,120,1,308,635,
1,306,640,1,519,
1401,16,0,120,1,
517,649,1,87,654,
1,728,1402,16,0,
120,1,84,664,1,
190,669,1,264,688,
1,73,1403,16,0,
120,1,930,1404,16,
0,120,1,394,1405,
16,0,120,1,274,
1406,16,0,120,1,
479,1407,16,0,120,
1,66,698,1,172,
703,1,595,1408,16,
0,120,1,57,1409,
16,0,120,1,265,
736,1,50,1410,16,
0,120,1,155,1411,
16,0,120,1,796,
1412,16,0,120,1,
44,1413,16,0,120,
1,471,758,1,470,
1414,16,0,120,1,
250,763,1,32,1415,
16,0,120,1,139,
1416,16,0,120,1,
27,1417,16,0,120,
1,878,1418,16,0,
120,1,18,1419,16,
0,120,1,124,1420,
16,0,120,1,14,
1421,16,0,120,1,
229,793,1,656,1422,
16,0,120,1,424,
621,1,8,810,1,
5,805,1,110,1423,
16,0,120,1,7,
815,1,754,1424,16,
0,120,1,209,801,
1,430,1425,16,0,
120,1,300,630,1,
15,1426,19,287,1,
15,1427,5,4,1,
471,758,1,84,664,
1,66,1428,16,0,
285,1,517,649,1,
14,1429,19,155,1,
14,1430,5,41,1,
424,621,1,423,626,
1,97,1431,17,1432,
15,1433,4,26,37,
0,70,0,105,0,
101,0,108,0,100,
0,69,0,120,0,
112,0,76,0,105,
0,115,0,116,0,
1,-1,1,5,1434,
20,452,1,104,1,
3,1,4,1,3,
1435,22,1,24,1,
308,635,1,306,640,
1,519,644,1,86,
1436,16,0,233,1,
517,649,1,87,654,
1,300,630,1,84,
664,1,190,669,1,
73,678,1,264,688,
1,479,693,1,66,
698,1,172,703,1,
595,673,1,379,1437,
17,1438,15,1433,1,
-1,1,5,1439,20,
447,1,105,1,3,
1,6,1,5,1440,
22,1,25,1,57,
707,1,911,1441,16,
0,156,1,909,1442,
16,0,153,1,265,
736,1,50,741,1,
155,750,1,900,1443,
17,1444,15,1445,4,
20,37,0,70,0,
105,0,101,0,108,
0,100,0,76,0,
105,0,115,0,116,
0,1,-1,1,5,
1446,20,534,1,88,
1,3,1,6,1,
5,1447,22,1,8,
1,471,758,1,898,
1448,17,1449,15,1445,
1,-1,1,5,1450,
20,540,1,87,1,
3,1,4,1,3,
1451,22,1,7,1,
139,772,1,250,763,
1,32,767,1,18,
784,1,124,789,1,
229,793,1,656,797,
1,8,810,1,110,
823,1,7,815,1,
5,805,1,209,801,
1,430,827,1,13,
1452,19,160,1,13,
1453,5,2,1,84,
1454,16,0,235,1,
904,1455,16,0,158,
1,12,1456,19,111,
1,12,1457,5,35,
1,424,621,1,423,
626,1,308,635,1,
306,640,1,519,644,
1,517,649,1,87,
654,1,300,630,1,
84,664,1,190,669,
1,73,678,1,264,
688,1,66,698,1,
172,703,1,265,736,
1,595,673,1,57,
707,1,479,693,1,
50,741,1,155,750,
1,471,758,1,470,
1458,16,0,109,1,
139,772,1,250,763,
1,32,767,1,18,
784,1,124,789,1,
229,793,1,656,797,
1,209,801,1,8,
810,1,7,815,1,
5,805,1,110,823,
1,430,827,1,11,
1459,19,119,1,11,
1460,5,4,1,471,
758,1,84,664,1,
66,1461,16,0,117,
1,517,649,1,10,
1462,19,175,1,10,
1463,5,46,1,424,
621,1,423,626,1,
422,1464,16,0,176,
1,421,1465,17,1466,
15,1467,4,20,37,
0,80,0,97,0,
114,0,97,0,109,
0,76,0,105,0,
115,0,116,0,1,
-1,1,5,1468,20,
454,1,103,1,3,
1,4,1,3,1469,
22,1,23,1,87,
654,1,308,635,1,
306,640,1,305,1470,
16,0,238,1,517,
649,1,301,922,1,
300,630,1,84,664,
1,190,669,1,264,
688,1,73,678,1,
394,1471,17,1472,15,
1467,1,-1,1,5,
1473,20,459,1,102,
1,3,1,2,1,
1,1474,22,1,22,
1,172,703,1,274,
927,1,479,693,1,
66,698,1,386,1475,
16,0,173,1,595,
673,1,57,707,1,
266,1476,16,0,247,
1,265,736,1,50,
741,1,155,750,1,
900,1443,1,471,758,
1,898,1448,1,32,
767,1,250,763,1,
784,1477,16,0,248,
1,139,772,1,519,
644,1,18,784,1,
124,789,1,229,793,
1,656,797,1,840,
1478,16,0,182,1,
209,801,1,8,810,
1,7,815,1,5,
805,1,110,823,1,
430,827,1,9,1479,
19,193,1,9,1480,
5,38,1,746,1481,
16,0,288,1,102,
1482,16,0,288,1,
844,1483,16,0,288,
1,201,1484,16,0,
288,1,814,1485,16,
0,288,1,89,1486,
16,0,288,1,407,
1487,16,0,288,1,
84,1488,16,0,191,
1,720,1489,16,0,
288,1,77,1490,16,
0,288,1,182,1491,
16,0,288,1,287,
1492,16,0,288,1,
67,1493,16,0,288,
1,386,1494,16,0,
288,1,60,1495,16,
0,288,1,164,1496,
16,0,288,1,266,
1497,16,0,288,1,
51,1498,16,0,288,
1,242,1499,16,0,
288,1,45,1500,16,
0,288,1,472,1501,
16,0,288,1,39,
1502,16,0,288,1,
147,1503,16,0,288,
1,788,1504,16,0,
288,1,34,1505,16,
0,288,1,463,1506,
16,0,288,1,783,
1507,16,0,229,1,
28,1508,16,0,288,
1,131,1509,16,0,
288,1,23,1510,16,
0,288,1,19,1511,
16,0,288,1,15,
1512,16,0,288,1,
870,1513,16,0,288,
1,11,1514,16,0,
288,1,116,1515,16,
0,288,1,221,1516,
16,0,288,1,3,
1517,16,0,288,1,
0,1518,16,0,288,
1,8,1519,19,272,
1,8,1520,5,35,
1,424,621,1,423,
626,1,308,635,1,
306,640,1,519,644,
1,517,649,1,87,
654,1,300,630,1,
84,664,1,190,669,
1,274,1521,16,0,
270,1,73,678,1,
264,688,1,66,698,
1,172,703,1,265,
736,1,595,673,1,
57,707,1,479,693,
1,50,741,1,155,
750,1,471,758,1,
139,772,1,250,763,
1,32,767,1,18,
784,1,124,789,1,
229,793,1,656,797,
1,209,801,1,8,
810,1,7,815,1,
5,805,1,110,823,
1,430,827,1,7,
1522,19,136,1,7,
1523,5,4,1,841,
1524,16,0,209,1,
785,1525,16,0,228,
1,896,1526,16,0,
134,1,717,1527,16,
0,269,1,6,1528,
19,133,1,6,1529,
5,37,1,424,621,
1,423,626,1,97,
1530,16,0,196,1,
308,635,1,306,640,
1,519,644,1,517,
649,1,87,654,1,
300,630,1,84,664,
1,190,669,1,73,
678,1,394,1531,16,
0,187,1,264,688,
1,479,693,1,66,
698,1,172,703,1,
595,673,1,57,707,
1,265,736,1,50,
741,1,155,750,1,
471,758,1,898,1532,
16,0,131,1,139,
772,1,250,763,1,
32,767,1,18,784,
1,124,789,1,229,
793,1,656,797,1,
209,801,1,8,810,
1,7,815,1,5,
805,1,110,823,1,
430,827,1,5,1533,
19,302,1,5,1534,
5,36,1,746,1535,
16,0,300,1,102,
1536,16,0,300,1,
844,1537,16,0,300,
1,201,1538,16,0,
300,1,814,1539,16,
0,300,1,89,1540,
16,0,300,1,407,
1541,16,0,300,1,
720,1542,16,0,300,
1,77,1543,16,0,
300,1,182,1544,16,
0,300,1,287,1545,
16,0,300,1,67,
1546,16,0,300,1,
386,1547,16,0,300,
1,60,1548,16,0,
300,1,164,1549,16,
0,300,1,266,1550,
16,0,300,1,51,
1551,16,0,300,1,
45,1552,16,0,300,
1,472,1553,16,0,
300,1,39,1554,16,
0,300,1,147,1555,
16,0,300,1,788,
1556,16,0,300,1,
463,1557,16,0,300,
1,34,1558,16,0,
300,1,28,1559,16,
0,300,1,242,1560,
16,0,300,1,131,
1561,16,0,300,1,
23,1562,16,0,300,
1,19,1563,16,0,
300,1,15,1564,16,
0,300,1,870,1565,
16,0,300,1,11,
1566,16,0,300,1,
116,1567,16,0,300,
1,221,1568,16,0,
300,1,3,1569,16,
0,300,1,0,1570,
16,0,300,1,4,
1571,19,152,1,4,
1572,5,52,1,746,
1573,16,0,236,1,
102,1574,16,0,236,
1,844,1575,16,0,
236,1,201,1576,16,
0,236,1,842,1577,
16,0,208,1,814,
1578,16,0,236,1,
89,1579,16,0,236,
1,516,1580,16,0,
242,1,407,1581,16,
0,236,1,85,1582,
16,0,232,1,463,
1583,16,0,236,1,
720,1584,16,0,236,
1,77,1585,16,0,
236,1,718,1586,16,
0,243,1,182,1587,
16,0,236,1,287,
1588,16,0,236,1,
67,1589,16,0,236,
1,386,1590,16,0,
236,1,164,1591,16,
0,236,1,60,1592,
16,0,236,1,915,
1593,16,0,306,1,
378,1594,16,0,232,
1,242,1595,16,0,
236,1,51,1596,16,
0,236,1,909,1597,
16,0,294,1,266,
1598,16,0,236,1,
907,1599,16,0,277,
1,904,1600,16,0,
150,1,902,1601,16,
0,172,1,45,1602,
16,0,236,1,472,
1603,16,0,236,1,
899,1604,16,0,294,
1,39,1605,16,0,
236,1,897,1606,16,
0,181,1,147,1607,
16,0,236,1,788,
1608,16,0,236,1,
786,1609,16,0,246,
1,784,1610,16,0,
294,1,34,1611,16,
0,236,1,782,1612,
16,0,230,1,28,
1613,16,0,236,1,
131,1614,16,0,236,
1,23,1615,16,0,
236,1,19,1616,16,
0,236,1,15,1617,
16,0,236,1,870,
1618,16,0,236,1,
9,1619,16,0,306,
1,11,1620,16,0,
236,1,116,1621,16,
0,236,1,221,1622,
16,0,236,1,3,
1623,16,0,236,1,
0,1624,16,0,236,
1,3,1625,19,305,
1,3,1626,5,36,
1,746,1627,16,0,
303,1,102,1628,16,
0,303,1,844,1629,
16,0,303,1,201,
1630,16,0,303,1,
814,1631,16,0,303,
1,89,1632,16,0,
303,1,407,1633,16,
0,303,1,720,1634,
16,0,303,1,77,
1635,16,0,303,1,
182,1636,16,0,303,
1,287,1637,16,0,
303,1,67,1638,16,
0,303,1,386,1639,
16,0,303,1,60,
1640,16,0,303,1,
164,1641,16,0,303,
1,266,1642,16,0,
303,1,51,1643,16,
0,303,1,45,1644,
16,0,303,1,472,
1645,16,0,303,1,
39,1646,16,0,303,
1,147,1647,16,0,
303,1,788,1648,16,
0,303,1,463,1649,
16,0,303,1,34,
1650,16,0,303,1,
28,1651,16,0,303,
1,242,1652,16,0,
303,1,131,1653,16,
0,303,1,23,1654,
16,0,303,1,19,
1655,16,0,303,1,
15,1656,16,0,303,
1,870,1657,16,0,
303,1,11,1658,16,
0,303,1,116,1659,
16,0,303,1,221,
1660,16,0,303,1,
3,1661,16,0,303,
1,0,1662,16,0,
303,1,2,1663,19,
116,1,2,1664,5,
34,1,424,621,1,
423,626,1,308,635,
1,306,640,1,519,
644,1,517,649,1,
87,654,1,300,630,
1,84,664,1,190,
669,1,73,678,1,
264,688,1,66,698,
1,172,703,1,265,
736,1,595,673,1,
57,707,1,479,693,
1,50,741,1,155,
750,1,471,758,1,
139,772,1,250,763,
1,32,767,1,18,
784,1,124,789,1,
229,793,1,656,797,
1,209,801,1,8,
810,1,7,815,1,
5,805,1,110,823,
1,430,827,2,1,0};
new Sfactory(this,"RecordTy",new SCreator(RecordTy_factory));
new Sfactory(this,"IfExp_3",new SCreator(IfExp_3_factory));
new Sfactory(this,"OpExp_1",new SCreator(OpExp_1_factory));
new Sfactory(this,"OpExp",new SCreator(OpExp_factory));
new Sfactory(this,"OpExp_4",new SCreator(OpExp_4_factory));
new Sfactory(this,"OpExp_6",new SCreator(OpExp_6_factory));
new Sfactory(this,"OpExp_7",new SCreator(OpExp_7_factory));
new Sfactory(this,"OpExp_9",new SCreator(OpExp_9_factory));
new Sfactory(this,"VarExp",new SCreator(VarExp_factory));
new Sfactory(this,"Var",new SCreator(Var_factory));
new Sfactory(this,"Dec",new SCreator(Dec_factory));
new Sfactory(this,"AssignExp",new SCreator(AssignExp_factory));
new Sfactory(this,"WhileExp_1",new SCreator(WhileExp_1_factory));
new Sfactory(this,"Exp",new SCreator(Exp_factory));
new Sfactory(this,"FieldExpList_2",new SCreator(FieldExpList_2_factory));
new Sfactory(this,"IntExp",new SCreator(IntExp_factory));
new Sfactory(this,"ForExp",new SCreator(ForExp_factory));
new Sfactory(this,"ExpList_1",new SCreator(ExpList_1_factory));
new Sfactory(this,"NilExp",new SCreator(NilExp_factory));
new Sfactory(this,"FieldVar",new SCreator(FieldVar_factory));
new Sfactory(this,"RecordExp_1",new SCreator(RecordExp_1_factory));
new Sfactory(this,"ArrayTy_1",new SCreator(ArrayTy_1_factory));
new Sfactory(this,"DecVar_2",new SCreator(DecVar_2_factory));
new Sfactory(this,"IfExp_2",new SCreator(IfExp_2_factory));
new Sfactory(this,"IfExp",new SCreator(IfExp_factory));
new Sfactory(this,"ExpList",new SCreator(ExpList_factory));
new Sfactory(this,"NameTy",new SCreator(NameTy_factory));
new Sfactory(this,"VarExp_1",new SCreator(VarExp_1_factory));
new Sfactory(this,"FunctionDec_1",new SCreator(FunctionDec_1_factory));
new Sfactory(this,"RecordTy_2",new SCreator(RecordTy_2_factory));
new Sfactory(this,"LetExp",new SCreator(LetExp_factory));
new Sfactory(this,"SimpleVar_1",new SCreator(SimpleVar_1_factory));
new Sfactory(this,"CallExp_1",new SCreator(CallExp_1_factory));
new Sfactory(this,"RecordTy_1",new SCreator(RecordTy_1_factory));
new Sfactory(this,"DecVar_1",new SCreator(DecVar_1_factory));
new Sfactory(this,"RecordExp",new SCreator(RecordExp_factory));
new Sfactory(this,"ArrayExp_1",new SCreator(ArrayExp_1_factory));
new Sfactory(this,"WhileExp",new SCreator(WhileExp_factory));
new Sfactory(this,"ArrayTy",new SCreator(ArrayTy_factory));
new Sfactory(this,"FieldList_1",new SCreator(FieldList_1_factory));
new Sfactory(this,"FieldList_2",new SCreator(FieldList_2_factory));
new Sfactory(this,"DecVar",new SCreator(DecVar_factory));
new Sfactory(this,"CallExp_2",new SCreator(CallExp_2_factory));
new Sfactory(this,"SubscriptVar_1",new SCreator(SubscriptVar_1_factory));
new Sfactory(this,"AssignExp_1",new SCreator(AssignExp_1_factory));
new Sfactory(this,"VarDec_1",new SCreator(VarDec_1_factory));
new Sfactory(this,"FunctionDec_2",new SCreator(FunctionDec_2_factory));
new Sfactory(this,"FunctionDec_3",new SCreator(FunctionDec_3_factory));
new Sfactory(this,"TypeDec_1",new SCreator(TypeDec_1_factory));
new Sfactory(this,"SeqExp_1",new SCreator(SeqExp_1_factory));
new Sfactory(this,"Null_1",new SCreator(Null_1_factory));
new Sfactory(this,"Ty",new SCreator(Ty_factory));
new Sfactory(this,"FieldExpList_1",new SCreator(FieldExpList_1_factory));
new Sfactory(this,"VarDec",new SCreator(VarDec_factory));
new Sfactory(this,"SeqExp_2",new SCreator(SeqExp_2_factory));
new Sfactory(this,"NameTy_1",new SCreator(NameTy_1_factory));
new Sfactory(this,"ParamList_1",new SCreator(ParamList_1_factory));
new Sfactory(this,"ParamList_2",new SCreator(ParamList_2_factory));
new Sfactory(this,"IntExp_1",new SCreator(IntExp_1_factory));
new Sfactory(this,"SubscriptVar",new SCreator(SubscriptVar_factory));
new Sfactory(this,"StringExp",new SCreator(StringExp_factory));
new Sfactory(this,"IfExp_4",new SCreator(IfExp_4_factory));
new Sfactory(this,"StringExp_1",new SCreator(StringExp_1_factory));
new Sfactory(this,"OpExp_11",new SCreator(OpExp_11_factory));
new Sfactory(this,"IfExp_1",new SCreator(IfExp_1_factory));
new Sfactory(this,"TypeDec",new SCreator(TypeDec_factory));
new Sfactory(this,"ArrayExp",new SCreator(ArrayExp_factory));
new Sfactory(this,"FieldVar_1",new SCreator(FieldVar_1_factory));
new Sfactory(this,"LetExp_1",new SCreator(LetExp_1_factory));
new Sfactory(this,"OpExp_8",new SCreator(OpExp_8_factory));
new Sfactory(this,"ExpList_2",new SCreator(ExpList_2_factory));
new Sfactory(this,"error",new SCreator(error_factory));
new Sfactory(this,"DecList",new SCreator(DecList_factory));
new Sfactory(this,"ForExp_1",new SCreator(ForExp_1_factory));
new Sfactory(this,"FieldExpList",new SCreator(FieldExpList_factory));
new Sfactory(this,"CallExp",new SCreator(CallExp_factory));
new Sfactory(this,"SimpleVar",new SCreator(SimpleVar_factory));
new Sfactory(this,"FunctionDec_4",new SCreator(FunctionDec_4_factory));
new Sfactory(this,"DecList_1",new SCreator(DecList_1_factory));
new Sfactory(this,"FunctionDec",new SCreator(FunctionDec_factory));
new Sfactory(this,"SeqExp",new SCreator(SeqExp_factory));
new Sfactory(this,"ParamList",new SCreator(ParamList_factory));
new Sfactory(this,"FieldList",new SCreator(FieldList_factory));
new Sfactory(this,"BreakExp_1",new SCreator(BreakExp_1_factory));
new Sfactory(this,"OpExp_2",new SCreator(OpExp_2_factory));
new Sfactory(this,"OpExp_3",new SCreator(OpExp_3_factory));
new Sfactory(this,"OpExp_5",new SCreator(OpExp_5_factory));
new Sfactory(this,"OpExp_10",new SCreator(OpExp_10_factory));
new Sfactory(this,"NilExp_1",new SCreator(NilExp_1_factory));
new Sfactory(this,"LetExp_2",new SCreator(LetExp_2_factory));
new Sfactory(this,"BreakExp",new SCreator(BreakExp_factory));
}
public static object RecordTy_factory(Parser yyp) { return new RecordTy(yyp); }
public static object IfExp_3_factory(Parser yyp) { return new IfExp_3(yyp); }
public static object OpExp_1_factory(Parser yyp) { return new OpExp_1(yyp); }
public static object OpExp_factory(Parser yyp) { return new OpExp(yyp); }
public static object OpExp_4_factory(Parser yyp) { return new OpExp_4(yyp); }
public static object OpExp_6_factory(Parser yyp) { return new OpExp_6(yyp); }
public static object OpExp_7_factory(Parser yyp) { return new OpExp_7(yyp); }
public static object OpExp_9_factory(Parser yyp) { return new OpExp_9(yyp); }
public static object VarExp_factory(Parser yyp) { return new VarExp(yyp); }
public static object Var_factory(Parser yyp) { return new Var(yyp); }
public static object Dec_factory(Parser yyp) { return new Dec(yyp); }
public static object AssignExp_factory(Parser yyp) { return new AssignExp(yyp); }
public static object WhileExp_1_factory(Parser yyp) { return new WhileExp_1(yyp); }
public static object Exp_factory(Parser yyp) { return new Exp(yyp); }
public static object FieldExpList_2_factory(Parser yyp) { return new FieldExpList_2(yyp); }
public static object IntExp_factory(Parser yyp) { return new IntExp(yyp); }
public static object ForExp_factory(Parser yyp) { return new ForExp(yyp); }
public static object ExpList_1_factory(Parser yyp) { return new ExpList_1(yyp); }
public static object NilExp_factory(Parser yyp) { return new NilExp(yyp); }
public static object FieldVar_factory(Parser yyp) { return new FieldVar(yyp); }
public static object RecordExp_1_factory(Parser yyp) { return new RecordExp_1(yyp); }
public static object ArrayTy_1_factory(Parser yyp) { return new ArrayTy_1(yyp); }
public static object DecVar_2_factory(Parser yyp) { return new DecVar_2(yyp); }
public static object IfExp_2_factory(Parser yyp) { return new IfExp_2(yyp); }
public static object IfExp_factory(Parser yyp) { return new IfExp(yyp); }
public static object ExpList_factory(Parser yyp) { return new ExpList(yyp); }
public static object NameTy_factory(Parser yyp) { return new NameTy(yyp); }
public static object VarExp_1_factory(Parser yyp) { return new VarExp_1(yyp); }
public static object FunctionDec_1_factory(Parser yyp) { return new FunctionDec_1(yyp); }
public static object RecordTy_2_factory(Parser yyp) { return new RecordTy_2(yyp); }
public static object LetExp_factory(Parser yyp) { return new LetExp(yyp); }
public static object SimpleVar_1_factory(Parser yyp) { return new SimpleVar_1(yyp); }
public static object CallExp_1_factory(Parser yyp) { return new CallExp_1(yyp); }
public static object RecordTy_1_factory(Parser yyp) { return new RecordTy_1(yyp); }
public static object DecVar_1_factory(Parser yyp) { return new DecVar_1(yyp); }
public static object RecordExp_factory(Parser yyp) { return new RecordExp(yyp); }
public static object ArrayExp_1_factory(Parser yyp) { return new ArrayExp_1(yyp); }
public static object WhileExp_factory(Parser yyp) { return new WhileExp(yyp); }
public static object ArrayTy_factory(Parser yyp) { return new ArrayTy(yyp); }
public static object FieldList_1_factory(Parser yyp) { return new FieldList_1(yyp); }
public static object FieldList_2_factory(Parser yyp) { return new FieldList_2(yyp); }
public static object DecVar_factory(Parser yyp) { return new DecVar(yyp); }
public static object CallExp_2_factory(Parser yyp) { return new CallExp_2(yyp); }
public static object SubscriptVar_1_factory(Parser yyp) { return new SubscriptVar_1(yyp); }
public static object AssignExp_1_factory(Parser yyp) { return new AssignExp_1(yyp); }
public static object VarDec_1_factory(Parser yyp) { return new VarDec_1(yyp); }
public static object FunctionDec_2_factory(Parser yyp) { return new FunctionDec_2(yyp); }
public static object FunctionDec_3_factory(Parser yyp) { return new FunctionDec_3(yyp); }
public static object TypeDec_1_factory(Parser yyp) { return new TypeDec_1(yyp); }
public static object SeqExp_1_factory(Parser yyp) { return new SeqExp_1(yyp); }
public static object Null_1_factory(Parser yyp) { return new Null_1(yyp); }
public static object Ty_factory(Parser yyp) { return new Ty(yyp); }
public static object FieldExpList_1_factory(Parser yyp) { return new FieldExpList_1(yyp); }
public static object VarDec_factory(Parser yyp) { return new VarDec(yyp); }
public static object SeqExp_2_factory(Parser yyp) { return new SeqExp_2(yyp); }
public static object NameTy_1_factory(Parser yyp) { return new NameTy_1(yyp); }
public static object ParamList_1_factory(Parser yyp) { return new ParamList_1(yyp); }
public static object ParamList_2_factory(Parser yyp) { return new ParamList_2(yyp); }
public static object IntExp_1_factory(Parser yyp) { return new IntExp_1(yyp); }
public static object SubscriptVar_factory(Parser yyp) { return new SubscriptVar(yyp); }
public static object StringExp_factory(Parser yyp) { return new StringExp(yyp); }
public static object IfExp_4_factory(Parser yyp) { return new IfExp_4(yyp); }
public static object StringExp_1_factory(Parser yyp) { return new StringExp_1(yyp); }
public static object OpExp_11_factory(Parser yyp) { return new OpExp_11(yyp); }
public static object IfExp_1_factory(Parser yyp) { return new IfExp_1(yyp); }
public static object TypeDec_factory(Parser yyp) { return new TypeDec(yyp); }
public static object ArrayExp_factory(Parser yyp) { return new ArrayExp(yyp); }
public static object FieldVar_1_factory(Parser yyp) { return new FieldVar_1(yyp); }
public static object LetExp_1_factory(Parser yyp) { return new LetExp_1(yyp); }
public static object OpExp_8_factory(Parser yyp) { return new OpExp_8(yyp); }
public static object ExpList_2_factory(Parser yyp) { return new ExpList_2(yyp); }
public static object error_factory(Parser yyp) { return new error(yyp); }
public static object DecList_factory(Parser yyp) { return new DecList(yyp); }
public static object ForExp_1_factory(Parser yyp) { return new ForExp_1(yyp); }
public static object FieldExpList_factory(Parser yyp) { return new FieldExpList(yyp); }
public static object CallExp_factory(Parser yyp) { return new CallExp(yyp); }
public static object SimpleVar_factory(Parser yyp) { return new SimpleVar(yyp); }
public static object FunctionDec_4_factory(Parser yyp) { return new FunctionDec_4(yyp); }
public static object DecList_1_factory(Parser yyp) { return new DecList_1(yyp); }
public static object FunctionDec_factory(Parser yyp) { return new FunctionDec(yyp); }
public static object SeqExp_factory(Parser yyp) { return new SeqExp(yyp); }
public static object ParamList_factory(Parser yyp) { return new ParamList(yyp); }
public static object FieldList_factory(Parser yyp) { return new FieldList(yyp); }
public static object BreakExp_1_factory(Parser yyp) { return new BreakExp_1(yyp); }
public static object OpExp_2_factory(Parser yyp) { return new OpExp_2(yyp); }
public static object OpExp_3_factory(Parser yyp) { return new OpExp_3(yyp); }
public static object OpExp_5_factory(Parser yyp) { return new OpExp_5(yyp); }
public static object OpExp_10_factory(Parser yyp) { return new OpExp_10(yyp); }
public static object NilExp_1_factory(Parser yyp) { return new NilExp_1(yyp); }
public static object LetExp_2_factory(Parser yyp) { return new LetExp_2(yyp); }
public static object BreakExp_factory(Parser yyp) { return new BreakExp(yyp); }
}
public class syntax: Parser {
public syntax():base(new yysyntax(),new tokens()) {}
public syntax(YyParser syms):base(syms,new tokens()) {}
public syntax(YyParser syms,ErrorHandler erh):base(syms,new tokens(erh)) {}

 }
}
